\ RS232 in- en uitvoer met, als extra uitvoer naar LEDS: 294 bytes.

90S2313                                 \ Compileer voor AT90S2313
NEEDS TARGET.FRT

PORTB SFR LEDS                          \ Poort-B met 8 leds
UBRR  SFR RS232-SNELHEID
UCR   SFR RS232-MODE
UDR   SFR RS232-BUFFER

USR 5 BIT-SFR EMIT? ( -- flag )         \ True als zender nog bezig is
USR 7 BIT-SFR KEY?  ( -- flag )         \ True als ontvang buffer vol is

: RS232-SETUP   ( -- )                  \ Installeer RS232
    103 TO RS232-SNELHEID               \ Selecteer 2400 baud
    $18 TO RS232-MODE                   \ RS232 ontvanger en zender aan
    ;                                   \ Geen interrupt en 8 bits data.

: EMIT          ( char -- )             \ Stuur karakter via RS232
    BEGIN  EMIT? UNTIL
    TO RS232-BUFFER
    ;

: TYPE          ( $addr u -- )          \ Stuur ROM string via RS232
    ?DUP IF
        0 DO
            COUNT EMIT
        LOOP
    THEN
    2DROP
    ;

: KEY           ( -- char )             \ Ontvang karakter via RS232
    BEGIN  KEY? UNTIL
    RS232-BUFFER
    ;


\ Een klein RS232 tekst in- uitvoer voorbeeld

ATOM INLINE$        ( -- $addr u )      \ Importeer string literal macro

: CR        ^M EMIT  ^J EMIT ;          \ Nieuwe regel
: PAGE      ^L EMIT ;                   \ Maak beeldscherm schoon

: NAAR-LEDS         ( x -- )            \ Toon data op LEDS
    INVERT TO LEDS
    ;

: BEHANDEL-INVOER   ( -- )              \ Handel karakter invoer af
    BEGIN
        CR ." > " KEY  DUP NAAR-LEDS    \ Copieer karakter op LEDS
        DUP &A = IF  ." Aap "   THEN
        DUP &B = IF  ." Boef "  THEN
        DUP &C = IF  ." Chip "  THEN
    &Q = UNTIL
    ;

: TEKST-I/O         ( -- )              \ RS232 tekst in- uitvoer proef
    SETUP
    RS232-SETUP
    BEGIN
        PAGE ." RS232 I/O proef voor AVR mcu"
        BEHANDEL-INVOER
    AGAIN
    ;  MAIN

\ Einde