\ Een motor vermogensregeling via Puls Breedte Modulatie, 122 bytes

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

TCCR0 SFR TIMER-CONTROLE0               \ Hardware registers
TCNT0 SFR COUNTER0
TIMSK SFR TIMER-INT

#15 CONSTANT CYCLUS                     \ PBM Lengte
REGISTER PERIODE                        \ PBM Duur
REGISTER AANPULS                        \ PBM aantijd
REGISTER AANTIJD                        \ PBM werkregister
PORTB 0 BIT-SFR UITGANG                 \ PB.0

: SETUP-PBM         ( -- )              \ Stel PBM in op 66 Hz
    CYCLUS TO PERIODE
    -63 TO COUNTER0
    2 TO TIMER-INT
    3 TO TIMER-CONTROLE0
    1 SETDIR UITGANG
    INTERRUPT-ON
    ;

\ Ongeveer 25 cycles van elke 4032 wordt voor PBM gebruikt = .625 %
CODE PBM            ( -- )              \ PBM opwekking
    R16 PUSH,
    R16 -63 LDI,
    TCNT0 R16 OUT,
    ADR AANTIJD TST,                    \ Aantijd verstreken ?
    ZER IF,
        ADR UITGANG CBI,                \ Ja, uitgang laag !
    ELSE,
        ADR UITGANG SBI,                \ Nee, uitgang hoog en verlaag aantijd
        ADR AANTIJD DEC,
    THEN,
    ADR PERIODE DEC,                    \ Cyclus verstreken ?
    ZER IF,
        ADR AANTIJD ADR AANPULS MOV,    \ Ja, zet aantijd in werkregister
        R16 CYCLUS LDI,                 \ en stel cyclusduur in
        ADR PERIODE R16 MOV,
    THEN,
    R16 POP,
    RETI,
END-CODE  T0-OVERFLOW

: ZET-PULSBREEDTE   ( u -- )            \ Zet snelheid van 0 to 15
    CYCLUS UMIN  TO AANPULS
    ;


\ Motor regeling demonstratie

PORTD SFR INGANG                        \ Ingang met de schakelaars PD.0-PD.3

: ZET-SNELHEID      ( -- u )            \ Lees schakelaar en inverteer
    FROM INGANG INVERT  $F AND          \ het resultaat, laagste 4 bits zijn
    ZET-PULSBREEDTE                     \ geldig. Zet de motorsnelheid.
    ;

: REGEL-MOTOR       ( -- )              \ Regel een gelijkstroom motor
    SETUP   SETUP-PBM
    $F0 SETDIR INGANG  $FF TO INGANG
    BEGIN  ZET-SNELHEID  AGAIN
    ;  MAIN

                              ( Einde )
