\ Puls afstand meting (TOERENTELLER, rondentijd, afst-meter etc.) 888 bytes.

90S2313                                 \ Compileer voor AT90S2313
NEEDS TARGET.FRT                        \ Voeg labels toe
NEEDS RS232.FRT                         \ RS232 (9600 baud) en
NEEDS NUMBERS.FRT                       \ getal uitvoer
ATOM INLINE$                            \ Importeer string macro


\ Start tijdmeting routines

PORTD 2 BIT-SFR IN                      \ Periode meet ingang PD.2
PORTD 5 BIT-SFR STARTKNOP               \ Start meting PD.5
TIMSK   SFR TIMER-INT                   \ Timer interrupt besturing
TCCR0   SFR TIMER-CONTROLE              \ Timer 0 mode
TCNT0   SFR TIMER                       \ Timer 0 werkregister
GIMSK   SFR INT-MASKER                  \ Algemeen interrupt masker
MCUCR   SFR INT-CONTROLE                \ Geef activerings type aan

REGISTER TELLERLAAG                     \ Periodetijd teller
REGISTER TELLERHOOG

REGISTER MEETTIJDLAAG                   \ Onthoud periodetijd
REGISTER MEETTIJDHOOG

FLAG DENDER?                            \ Dender onderdrukking
FLAG METING?                            \ Complete meting gedaan
FLAG KLAAR?                             \ Start een meetcyclus

\ Interrupt routine voor periodetijd meter, de maximaal te meten
\ periodetijd is: 65535 * 1/1000 sec = 65,5 sec. De kortste tijd
\ in principe 4 millisec. maar deze kan er bijna 20 % naast zitten.
CODE TEL                ( -- )          \ Wordt elke 1/1000 sec geactiveerd
    R16 PUSH,                           \ Bewaar gebruikte registers
    R17 PUSH,
    R17 SREG IN,
    R16 -62 LDI,                        \ Zet negatieve 8-bits waarde in timer 0
    TCNT0 R16 OUT,
    ADR TELLERLAAG INC,                 \ Verhoog lage byte teller
    ZER IF,                             \ Overflow ?
        ADR TELLERHOOG INC,             \ Ja, verhoog hoge byte
    THEN,
    R16 ADR TELLERLAAG MOV,             \ Dender onderdrukking van 4 millisec.
    R16 4 CPI,
    ZER IF,
        CLT,                            \ Ja, sta nieuw signaal toe
        ADR DENDER? BLD,
    THEN,
    SREG R17 OUT,                       \ Herstel gebruikte registers
    R17 POP,
    R16 POP,
    RETI,
END-CODE  T0-OVERFLOW

CODE NOTEER             ( -- )          \ Noteer periode tijd
    R17 PUSH,
    R17 SREG IN,
    ADR KLAAR? BST,
    TS IF,  RETI,  THEN,                \ Meting afgerond? doe dan niets !
    ADR DENDER? BST,
    TC IF,                              \ Ingang vrij gegeven ?
        ADR METING? BST,
        TC IF,                          \ Begin een meting ?
            ADR TELLERLAAG CLR,         \ Ja, reset teller
            ADR TELLERHOOG CLR,
            SET,
        ELSE,
            ADR MEETTIJDLAAG ADR TELLERLAAG MOV, \ Nee, bewaar periodetijd
            ADR MEETTIJDHOOG ADR TELLERHOOG MOV,
            SET,
            ADR KLAAR? BLD,             \ Meetcyclus afgerond
            CLT,
        THEN,
        ADR METING? BLD,
    THEN,
    SET,
    ADR DENDER? BLD,                    \ Activeer dender onderdrukking
    R17 POP,
    RETI,
END-CODE  EXTERN0

: TIJDMETING-SETUP      ( -- )
    0 SETDIR IN  0 SETDIR STARTKNOP     \ In en startknop zijn ingangen
    SET IN  SET STARTKNOP               \ met pullup weerstand
    2 TO TIMER-INT                      \ Timer-0 interrupt aan
    3 TO TIMER-CONTROLE                 \ Prescaler= (deel cpu klok door) 64
    -62 TO TIMER                        \ Zet timer-0 register startwaarde
    $40 TO INT-MASKER                   \ Activeer PD.2 op lage flanken
    2 TO INT-CONTROLE
    CLEAR METING?                       \ Nog geen meetcyclus begonnen
    CLEAR DENDER?                       \ Dender onderdrukking niet actief
    SET KLAAR?                          \ Meetcyclus niet actief
    ;

: START-METING          ( -- )
    BEGIN  10 MS  FROM STARTKNOP 0= UNTIL \ Knop ingedrukt
    BEGIN  10 MS  FROM STARTKNOP UNTIL    \ Knop losgelaten
    CLEAR KLAAR?
    ;

: BEREKEN-TOERENTAL     ( -- ud )       \ Converteer periodetijd naar omw/min
    60000. 0. MEETTIJDLAAG MEETTIJDHOOG
    DUM/MOD 2NIP
    ;

\ Toon unsigned dubbel getal.
: DU.                   ( ud -- )
    <# #S #> RTYPE SPACE
    ;

: TOON-METING           ( -- )
    BEGIN  KLAAR? UNTIL                 \ Wacht tot meting gedaan is,
    CR ." Duur van een meting: "
    FROM MEETTIJDLAAG  MEETTIJDHOOG DU. \ print dan de periodetijd en
    ." millisec."
    CR ." Toerental: "
    BEREKEN-TOERENTAL DU.               \ bereken en print het toerental
    ." omw/min. "  50 MS
    ;

\ Het meetbereik is in de huidige configuratie van 1 tot 15000 toeren.
: TIJDMETING            ( -- )
    SETUP  TIJDMETING-SETUP  SETUP-RS232
    DECIMAL  CLEAR MEETTIJDLAAG  CLEAR MEETTIJDHOOG
    100 MS  PAGE CR ." 'Egel toerentalmeter" CR
    BEGIN
        START-METING  TOON-METING
    AGAIN
    ;  MAIN

\ End
