\ RC5 zender voor 6 MHz kristal, 178 bytes.

90S2313                                 \ Compileer voor AT90S2313
NEEDS TARGET.FRT

PORTD 6 BIT-SFR UITGANG                 \ RC5 uitgangs bit
PORTD 3 BIT-SFR INGANG                  \ RC5 Schakelaar ingang
PORTd 2 BIT-SFR LED                     \ RC5 Led uitgang

$E0 CONSTANT RC-TYPE                    \ RC5 Zender type (hier TV)

CODE HALVE-BIT      ( -- )              \ Wacht 878 us = 3512 (3506) tiks
    R17 6 LDI,                          \ 1 tik
    DO,
        R18 193 LDI,                    \ 1 tik
        DO,  R18 LOOP,                  \ R18 x 3 tiks = 582
    R17 LOOP,                           \ 3 tiks
    RET,                                \ 4 + 3 tiks
END-CODE

: EEN               ( -- )              \ Zend hoog bit (1755) 1768 us
    CLEAR UITGANG                       \ .5 us
    HALVE-BIT                           \ 876.5 us
    SET UITGANG                         \ .5 us
    HALVE-BIT                           \ 876.5 us
    ;                                   \ 1 + .75 us

: NUL               ( -- )              \ Zend laag bit 1755 us
    SET UITGANG
    HALVE-BIT
    CLEAR UITGANG
    HALVE-BIT
    ;

CODE ZEND-RC        ( -- )              \ Zend R3 bits uit de accu R19 * 1757 us
    DO,
        R16 LSL,                        \ .25 us
        CS IF,                          \ .5 us
            ' EEN GCALL,                \ 1755
        ELSE,                           \ .5 us
            ' NUL GCALL,                \ 1755 us
        THEN,
    R19 LOOP,                           \ .75 us
    RET,                                \ 1 + .75 us
END-CODE

CODE RCEMIT         ( x -- )            \ Zend 'x' naar een tv of videorec.
    R21 GIMSK IN,                       \ Hardware interrupts uit
    R22 R21 MOV,                        \ 1 + 1 + 1 + 1 = 4 tiks
    R21 $3F ANDI,
    GIMSK R21 OUT,
    R16 X+ LD,                          \ 2, Pak het commando
    R16 LSL,                            \ 1 + 1, Sla twee hoge bits over
    R16 LSL,
    R20 R16 MOV,                        \ 1, Bewaar commando
    R16 RC-TYPE LDI,                    \ 1, Systeem data (zender type)
    R19 8 LDI,                          \ 1, Zend ook de start bits
    ' ZEND-RC GCALL,                    \ (1757 us * 8) 
    R16 R20 MOV,
    R19 6 LDI,                          \ 1 + 1, Zend een 6 bit RC5 commando
    ' ZEND-RC GCALL,                    \ (1757 us * 6) + 2
    ADR UITGANG CBI,                    \ 2, Zet 36 KHz osc uit.
    GIMSK R22 OUT,                      \ 1, HW-int. weer aan
    RET,                                \ 7 tiks
END-CODE

: 10MS              ( u -- )            \ Wacht u maal 10 millisec.
    FOR  10 MS  NEXT
    ;

: FLITS             ( -- )              \ Laat LED flitsen
    CLEAR LED  50 10MS
    SET LED    50 10MS
    ;

: RC-ZENDER         ( -- )              \ Zend een RC start code
    SETUP  1 SETDIR UITGANG  1 SETDIR LED
    0 SETDIR INGANG  CLEAR UITGANG      \ Uitgang uit
    BEGIN
        FLITS                           \ Toon activering
        BEGIN  FROM INGANG 0= UNTIL     \ Wacht op toetsaanslag
        12 RCEMIT                       \ Zend aan/uit code
    AGAIN
    ;  MAIN
