\ Aansturing van vier zevensegment display's, 608 bytes.

90S2313                                 \ Compileer voor AT90S2313
NEEDS TARGET.FRT

\ u*8 bits uitvoer gebruikt altijd 3 I/O-bits

PORTB SFR UIT
PORTB 4 BIT-SFR LED                     \ Leds tussen display aan/uit
PORTB 5 BIT-SFR DATA                    \ Data bitstroom   (14=Data  )
PORTB 6 BIT-SFR KLOK                    \ Klok             (13=Clock )
PORTB 7 BIT-SFR KLAAR                   \ Data geldig      (15=Strobe)

: SCHRIJF-BIT       ( flag -- )         \ Schrijf een bit naar uitgang
    TO DATA  CLEAR KLOK SET KLOK
    ;

: TOON              ( -- )              \ Zet data op uitgangen
    SET KLAAR CLEAR KLAAR
    ;
 
: >DRIVER           ( x -- )            \ Schrijf x naar display
    8 FOR                               \ display driver
        DUP 128 AND SCHRIJF-BIT  2*
    NEXT
    DROP
    ;

\ Maak cijfers voor een zevensegment display via de 74HC4094 0 t/m F
\ De digits staan in omgekeerde volgorde op de stack bij CONSTANTS !!!
\ Layout van 7segm. Display  +-A-+
\                            F   B
\ Uitsturing 74HC4094        +-G-+
\  PBCAFDGE                  E   C
\ Q87654321                  +-D-+
                                                  \ opbouw van tekens
  %00011011   %00011111   %01100111   %00011101   \ F , E , d , C
  %00101111   %01111011   %01111110   %01111111   \ b , A , 9 , 8
  %01110000   %00111111   %00111110   %01101010   \ 7 , 6 , 5 , 4
  %01110110   %01010111   %01100000   %01111101   \ 3 , 2 , 1 , 0
  16 CONSTANTS CIJFERS

VARIABLE PUNT                           \ Onthoud decimale punt

: ZET-PUNT          ( x1 u -- x2 )
    FROM PUNT =  $80 AND  OR
    ;

: >DISPLAY          ( adr u -- )        \ Stuur u getal digits van RAM-adres
    FOR                                 \ naar het 7-segment display
        @+  16 UMIN  CIJFERS            \ Van binair naar 7-segment
        I' ZET-PUNT  >DRIVER
    NEXT  
    2DROP  TOON                         \ en laat ze zien !
    ;

4 CONSTANT #DIGITS                      \ Aantal gebruikte 7-segm. display's
                                        \ en 74HC4094 chips.

: RTYPE             ( adr u -- )        \ Type getal op 7-segm. display's
    #DIGITS OVER U> IF                  \ Getal is minder dan #DIGITS lang ?
        #DIGITS OVER - FOR              \ Ja, vul aan met lege digits
            0  OVER I' + ZET-PUNT >DRIVER
        NEXT
        DUP 0= IF DROP 2DROP EXIT THEN  \ Stop als u nul is !!!
    THEN
    #DIGITS UMIN >DISPLAY               \ Type getal van max. #DIGITS
    ;

: 10MS  FOR 10 MS  NEXT ;  ( u -- )     \ Wacht u maal 10 ms

\ Getal uitvoer routines

ATOM UM/MOD                             \ Importeer enkele macros als woord
VARIABLE BASE                           \ Getal conversie basis
VARIABLE HLD                            \ Werk adr. in getal conv. buffer
#10 CONSTANT NUM                        \ Lengte van getal conversie buffer
NUM VARIABLES CONV                      \ Reserveer getal conversie buffer
ADR CONV 2CONSTANT NUMSTART

: M/MOD     ( d1 u1 -- u2 d2 )          \ Deel dubbel met teken door single
    >R  0  R@ UM/MOD  R> SWAP >R  UM/MOD R> \ zonder teken.
    ;

\ Getal uitvoer primitieven

\ Zet digit in de uitvoer buffer
: HOLD      DECR HLD  FROM HLD TO CONV ;                ( digit -- )

\ Initialiseer de uitvoer buffer
: <#        NUM TO HLD ;                                ( -- )

\ Beeindig getal conversie, geef addr en lengte u van de string in de buffer
: #>        2DROP  NUMSTART FROM HLD M+  NUM FROM HLD - ;      ( d -- addr u )

\ Zet een digit van d1 in de uitvoer buffer, d2 blijft over
: #         FROM BASE M/MOD  ROT HOLD ;                 ( d1 -- d2 )

\ Converteer digits van d1 als beschreven bij # tot het resultaat d2 nul is
: #S        BEGIN  # 2DUP OR 0= UNTIL ;                 ( d1 -- d2 )

\ Getal uitvoer woorden

\ Toon ud in een vrij formaat veld.
: DU.       <# #S #>  RTYPE ;                           ( ud -- )

\G Toon u in een vrij formaat veld.
: U.        0  DU. ;                                    ( u -- )

\ Zet getal conversie basis decimaal
: DECIMAL   #10 TO BASE ;                               ( -- )

\ Zet getal conversie basis hexadecimaal
: HEX       #16 TO BASE ;                               ( -- )

\ Einde getal uitvoer
\ Voorbeeld een teller met drie 7-segment display's

: WIJZIG-BASE   ( -- )
    FROM BASE #10 = IF                  \ Getal basis decimaal ?
        HEX                             \ Ja, maak hem hexadecimaal
    ELSE
        DECIMAL                         \ Nee, maak hem decimaal
    THEN
    ;

: KNIPPER       ( -- )                  \ Toon opstarten
    3333. DU.  50 10MS
    4444. DU.  50 10MS
    ;

: TELLER        ( -- )                  \ Binaire teller op 7-segm. display's
    SETUP  $FF SETDIR UIT
    DECIMAL  TOON  KNIPPER              \ Initialiseer 7-segm. voorbeeld
    1 TO PUNT                           \ Zet decimale punt
    0                                   \ Zet teller op de stack
    BEGIN
        BEGIN
            1+  DUP U.                  \ Verhoog teller, en toon getal
            20 10MS                     \ Wacht heel even
        DUP 0= UNTIL                    \ Klokje rond ?
        WIJZIG-BASE                     \ Ja, ga van dec. naar hex. en andersom
    AGAIN                               \ Begin weer opnieuw
    ;  MAIN

\ Einde
