\ I2C uitvoer met een PCF8574 (298 bytes).

90S2313                                 \ Code draait op een AT90S2313
NEEDS TARGET.FRT

\ I2C primitieven voor een 6 MHz kristal

PORTD 4  BIT-SFR SDA                    \ Serieele data lijn
PORTD 5  BIT-SFR SCL                    \ Serieele klok lijn
$40 CONSTANT I/O-ID                     \ Device adres 0 van gebruikte chip

\ Algemene I2C primitieven

: WACHT          ( -- )
    2 FOR  NEXT                         \ Wacht 4.7 usec. bij 4 MHz xt.
    ;

: SETUP-I2C      ( -- )                 \ Setup I2C I/O bits
    1 SETDIR SDA  1 SETDIR SCL
    SET SDA  SET SCL
    ;

: START-BIT     ( -- )                  \ Genereer startbit
    SET SDA  SET SCL
    CLEAR SDA  WACHT
    CLEAR SCL  WACHT
    ;

: STOP-BIT      ( -- )                  \ Genereer stopbit
    CLEAR SDA  SET SCL  WACHT  SET SDA
    ;

: ACK?          ( -- vlag )             \ Test binnenkomend ackbit, vlag is
    SET SDA  SET SCL  0 SETDIR SDA
    WACHT  FROM SDA 0=  1 SETDIR SDA    \ true als er een ack ontvangen is
    CLEAR SCL  WACHT
    ;

: BYTE-UIT      ( byte -- )             \ Stuur byte en test ack
    8 FOR
        DUP 128 AND  TO SDA  2*
        SET SCL  WACHT  CLEAR SCL
    NEXT
    DROP  ACK? DROP                     \ Negeer Noack
    ;

\ Uitvoer routine voor PCF8574(a) chips

: !BYTE         ( byte chip -- )
    START-BIT
    $FE AND BYTE-UIT                    \ Stuur schrijfadres naar chip en
    BYTE-UIT                            \ daarna de databyte
    STOP-BIT                            \ Klaar
    ;

\ Onze eerste I2C toepassing een looplicht

: NAAR-LEDS     ( byte -- )             \ Stuur data naar PCF8574 op adres 0
    INVERT  $0F OR  I/O-ID !BYTE        \ De lage 4 bits zijn altijd hoog
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    255 NAAR-LEDS  250 MS
    0   NAAR-LEDS  250 MS
    ;

: LOOPLICHT     ( -- )                  \ Toon een looplicht op de leds
    SETUP  SETUP-I2C  KNIPPER
    BEGIN
        4 0 DO
            1 I 4 + LSHIFT NAAR-LEDS    \ Zet een led aan
            100 MS                      \ Wacht 100 millisec.
        LOOP
    AGAIN
    ;  MAIN
