\ PCF8583 of PCF8593, Een proef met klok en wekker, 1024 bytes.

90S2313                                 \ Code draait op een AT90S2313
NEEDS TARGET.FRT                        \ Laad nodige I2C-bibliotheken
NEEDS I2C-PRIM.FRT
NEEDS I2C-8583.FRT

$40 CONSTANT I/O-ID                     \ Device adres 0 van gebruikte chip

\ Uitvoer routine voor PCF8574(a) chips

: !BYTE         ( byte chip -- )
    START-BIT
    $FE AND BYTE-UIT                    \ Stuur schrijfadres naar chip en
    BYTE-UIT                            \ daarna de databyte
    STOP-BIT                            \ Klaar
    ;

: NAAR-LEDS     ( byte -- )             \ Stuur data naar PCF8574 op adres 0
    INVERT  $0F OR  I/O-ID !BYTE
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    255 NAAR-LEDS  250 MS
    0   NAAR-LEDS  250 MS
    ;

: VOLGENDE-WEK-TIJD ( -- )              \ Zet wektijd 10 sec na nu !!!
    WEK KLOK                            \ Reset wekker
    LEES-KLOK ROT 10 + >R               \ Maak nieuwe wek tijd (over 10 sec.)
    R@ 59 U> IF                         \ Meer dan 59 sec. ?
        R> 60 - >R                      \ Ja, corrigeer seconden
        SWAP 1+ >R  R@ 60 = IF          \ Verhoog min, meer dan 59 min. ?
            R> DROP  0 >R  1+           \ Ja, corrigeer minuten en uren
            DUP 24 = IF DROP 0 THEN     \ Dag verstreken, dan uren op nul
        THEN
        R> SWAP                         \ Herstel minuten
    THEN
    R> -ROT  ZET-WEK-TIJD               \ Herstel seconden
    ;

VARIABLE SEC                            \ Onthoud seconde

: TIK               ( -- )              \ Laat elke sec. een led flitsen
    LEES-KLOK 2DROP  DUP FROM SEC <> IF \ Seconde verstreken ?
        128 NAAR-LEDS                   \ Ja, laad hoogste led flitsen
        DUP TO SEC                      \ bewaar seconde
        25 MS  0 NAAR-LEDS
    THEN  
    DROP
    ;

: WEK-KLOK          ( -- )              \ Toon klok en wekker
    SETUP  SETUP-I2C  KNIPPER
    WEK KLOK  DAGELIJKSE WEKKER         \ Initialiseer klok
    BEGIN
        VOLGENDE-WEK-TIJD               \ Zet wekker vooruit
        BEGIN  TIK  WEKKER? UNTIL       \ Wacht tot wekker af loopt en flits
        KNIPPER                         \ Na aflopen alle leds even aan
    AGAIN
    ;  MAIN

\ Einde