\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : Test voor round Robin scheduler
\ DESCRIPTION : Looplicht, invoer & display routine op STK200
\ CATEGORY    : Applicatie, afmeting: 354 bytes.
\ AUTHOR      : Willem Ouwerkerk, April 30, 2002
\ LAST CHANGE : Willem Ouwerkerk, Juli 1, 2003
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel
11. 16 32 16 16 MAP                     \ Less RAM for stacks

NEEDS TASKER.FRT                        \ Laad multitasker

VARIABLE PATROON                        \ Doorgeef luikjes
VARIABLE TIJD

PORTB SFR LEDS                          \ Uitvoer
PORTD SFR TOETS                         \ Invoer


: SCHUIF    ( -- )                      \ Taak 1: Maak looplicht patroon
    CLEAR PATROON
    BEGIN
        FROM PATROON 2* TO PATROON
        FROM PATROON 0= IF
            1 TO PATROON
        THEN
        PAUSE
    AGAIN
    ;


: LEES      ( -- )                      \ Taak 2: Lees toets data in
    BEGIN
        FROM TOETS INVERT $7F AND
        1 UMAX 2* TO TIJD
        PAUSE
    AGAIN
    ;


: DISPLAY   ( -- )                      \ Taak 0: Setup en display
    SETUP-BYTEFORTH                     \ Initialiseer Forth systeem
    -1 SETDIR LEDS  0 SETDIR TOETS      \ en I/O-poorten.
    CLEAR LEDS 250 MS  SET LEDS 250 MS  \ Zet de leds even aan,
    CLEAR TASK#                         \ setup multitasker
    ['] SCHUIF  1 ACTIVATE              \ en activeer de taken.
    ['] LEES    2 ACTIVATE
    BEGIN
        FROM PATROON  INVERT TO LEDS    \ Toon patroon op de leds,
        PAUSE  FROM TIJD MS             \ switch en wacht even.
    AGAIN
    ;  MAIN


                              ( Einde )
