\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : 8515ADC.FRT
\ DESCRIPTION : Probeer ADC via comparator
\ CATEGORY    : Voorbeeld, afmeting: 158 bytes.
\ AUTHOR      : Willem Ouwerkerk, August 22, 2000
\ LAST CHANGE : Willem Ouwerkerk, August 22, 2000
\ ----------------------------------------------------------------------

90S8515                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

PORTB 2 BIT-SFR COMP+                   \ Comparator in- en uitgang(en)
PORTB 3 BIT-SFR COMP-
ACSR 5  BIT-SFR COMP-UIT

PORTD SFR LEDS                          \ Leds op poort D

: ONTLAAD-CONDENSATOR   ( -- )
    1 SETDIR COMP+  1 /MS               \ PB2 100 us laag
    ;

: SETUP-ADC             ( -- )
    CLEAR COMP-  CLEAR COMP+            \ Schakel pullups uit
    0 SETDIR COMP-  0 SETDIR COMP+      \ PB2 & PB3 zijn ingang
    ;

\ Zeven kloktikken per omzetting = 1.75 us per stap bij 4 MHz.
\ u is de omzettingstijd, dit is een maat voor de spanning op COMP-
CODE LAAD-CONDENSATOR   ( -- u )
    DDRB 2 CBI,                         \ COMP+ is ingang zonder pullup
    R16 CLR,                            \ Resultaat is nul
    BEGIN,
        NOP, NOP,
        R16 INC,                        \ Verhoog resultaat
    NZR WHILE,                          \ Stop als resultaat groter dan 255 is
        ADR COMP-UIT SBIS,              \ COMP+ groter dan COMP- ?
    REPEAT,
    R16 DEC,                            \ Klaar en corrigeer resultaat
    DDRB 2 SBI,                         \ COMP+ is lage uitgang (ontlaad C)
    -X R16 ST,                          \ Resultaat op datastack
    RET,
END-CODE

: ADC                   ( -- u )
    ONTLAAD-CONDENSATOR  LAAD-CONDENSATOR
    ;

: NAAR-LEDS             ( u -- )
    INVERT TO LEDS
    ;

: ANALOOG               ( -- )
    SETUP  SETUP-ADC  -1 SETDIR LEDS    \ Initialiseer het een en ander
    $FF NAAR-LEDS  250 MS               \ Toon opstarten
    $00 NAAR-LEDS  250 MS
    BEGIN
        ADC  NAAR-LEDS
    AGAIN
    ;  MAIN

                              ( Einde )
