\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : Ushi-3 test nummer 4
\ DESCRIPTION : Test de GP2D02- en/of MUS-sensor
\ CATEGORY    : Applicatie, afmeting: 176 bytes.
\ AUTHOR      : Willem Ouwerkerk, December 09, 2001
\ LAST CHANGE : Willem Ouwerkerk, Oktober 21, 2002
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel
4 SET-CRYSTAL                           \ Gebruik 4 MHz kristal
NEEDS MS.FRT                            \ Laad geschikte MS versie


PORTB SFR PB                            \ Met 8 leds
PORTD SFR PD                            \ Voor GP2D02

PORTD 0 BIT-SFR GP2-DATA                \ 0 (RX)
PORTD 1 BIT-SFR GP2-CONTROL             \ 1 (TX)


DOC het testen van de GP2D02

De leds van Ushi-3 zijn aangesloten op poort-B, op 
PD.0 en PD.1 is de GP2D02- of MUS-interface aangesloten.

Ushi toont op zijn leds de door de GP2D02 of MUS gemeten
afstand in binaire vorm, het binaire getal wordt groter
als de afstand toeneemt.

ENDDOC


\ GP2D02- of MUS-sensor om afstand te meten

MACRO: VOLGEND-BIT  ( x1 -- x2 )    \ Lees een databit
    SET GP2-CONTROL  1 /MS  CLEAR GP2-CONTROL
    2*  1 /MS  FROM GP2-DATA 0= 1 AND  OR
    ;

\ Geef afstand tot een object aan (lager is dichterbij).
\ Een meting duurt ongeveer 75 milliseconden.
: AFSTAND           ( -- afstand )  \ Lees afstand uit GP2D02 sensor
    SET GP2-DATA  CLEAR GP2-CONTROL \ activeer sensor en
    70 MS                           \ wacht even
    0  8 FOR                        \ begingetallen op de stack, neem
        VOLGEND-BIT                 \ acht maal een bit op
    NEXT
    SET GP2-CONTROL  2 MS           \ deactiveer sensor
    ;

\ Gebruik de leds om de door GP2D02 of MUS gemeten afstand te tonen
: AFSTANDEN         ( -- )
    AFSTAND  INVERT TO PB
    ;

:MAIN               ( -- )
    $FF SETDIR PB                   \ Poort-B is led uitgang
    $02 SETDIR PD                   \ Poort-D pin 1 is uitgang, rest ingang
    $FF TO PD                       \ Pullups op alle ingangen
    CLEAR PB 250 MS  SET PB 250 MS  \ Toon opstarten op de leds
    BEGIN
        AFSTANDEN
    AGAIN
    ;

                              ( Einde )
