\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : AVR-ADC.FRT
\ DESCRIPTION : Gebruik van ADC in sommige AVR chips
\ CATEGORY    : Voorbeeld, afmeting: 122 bytes.
\ AUTHOR      : Willem Ouwerkerk, March 16, 2000
\ LAST CHANGE : Willem Ouwerkerk, March 16, 2000
\ ----------------------------------------------------------------------

90S2333                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

DOC umentatie STK200-bord

Verbind pen-3 (Vo) van de connector waar 'LCD >' bij staat met
pen-1 van de connector waar 'Analog' bij staat.
Draai de AREF potmeter helemaal rechtsom, met de potmeter
daarnaast wordt nu de analoge spanning ingesteld.
De gemeten analoge waarde wordt op de leds getoond.

ENDDOC

ADMUX   SFR MULTIPLEXER                 \ Selecteer ingang
ADCSR   SFR STATUS                      \ Bestuur AD omzetter
ADCL    SFR DATA-LAAG                   \ Resultaat van een omzetting
ADCH    SFR DATA-HOOG

ADCSR 6 BIT-SFR START                   \ Activeer AD omzetting

: ADC               ( +n -- u )         \ Lees ingang +n de uitkomst is u
    5 UMIN  TO MULTIPLEXER              \ Selecteer een van de zes ingangen
    SET START                           \ Start de AD omzetting
    BEGIN  START 0= UNTIL               \ Wacht tot de omzetting klaar is
    DATA-LAAG  DATA-HOOG                \ 10 bits resultaat op de stack
    DU2/ DU2/ DROP                      \ Zet om naar 8 bit uitkomst
    ;                                   \ Als 10 bits i.p.v. 8 bits gewenst
                                        \ zijn verwijder dan 'DU2/ DU2/ DROP'

\ Demonstratie van het gebruik van de AD omzetter in sommige AVR chips


PORTB SFR LEDS                          \ 8 leds tonen het resultaat

: DEMO              ( -- )
    SETUP   $80 TO STATUS               \ ADC aan, prescaler is 2
    -1 SETDIR LEDS                      \ Leds zijn uitgangen
    CLEAR LEDS  250 MS                  \ Leds even aan
    BEGIN
        0 ADC  U2/ U2/ INVERT TO LEDS   \ Lees ingang nul en toon op leds
    AGAIN
    ;  MAIN

                              ( Einde )
