\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : AVR-PBM.FRT
\ DESCRIPTION : Pulsbreedte modulatie op zijn AVR's
\ CATEGORY    : Voorbeeld, afmeting: 84 bytes.
\ AUTHOR      : Willem Ouwerkerk, March 05, 2000
\ LAST CHANGE : Willem Ouwerkerk, Juli 22, 2002
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

TCCR1A SFR T1-CONTROLA                  \ Bestuur timer 1
TCCR1B SFR T1-CONTROLB
OCR1AL SFR POWER
PORTB 3 BIT-SFR PBM

\ Zet maximale PBM frequentie ~ 8 KHz bij een XT van 4 MHz.
: SETUP-PBM         ( -- )
    $81 TO T1-CONTROLA                  \ 8 bit PBM & normale PBM
    $01 TO T1-CONTROLB                  \ Gebruik CPU klok
    1 SETDIR PBM                        \ OC1 (PB.3) is uitgang
    CLEAR POWER                         \ PBM = 0
    ;

\ Demonstratie van het gebruik

: 10MS              ( u -- )            \ Wacht u maal 10 millisec.
    FOR  10 MS  NEXT
    ;

: DEMO              ( -- )
    SETUP  SETUP-PBM  255 10MS          \ Start op nul, wacht even
    BEGIN
        255 FOR                         \ Doorloop alle PBM standen
            I' TO POWER  10 10MS
        NEXT
    AGAIN
    ;  MAIN

                               ( End )
