\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : AVR-WDT.FRT
\ DESCRIPTION : Gebruik van de watchdog timer op de AVR
\ CATEGORY    : Voorbeeld, afmeting: 94 bytes.
\ AUTHOR      : Willem Ouwerkerk, March 05, 2000
\ LAST CHANGE : Willem Ouwerkerk, March 05, 2000
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

\ Demonstratie van het gebruik van de watchdog timer

PORTB SFR LEDS                          \ Leds op STK200 bord
PORTD 0 BIT-SFR INGANG                  \ Schakelaar PD0 op STK200 bord

\ De watchdog wordt alleen gereset als schakelaar PD0 ingedrukt is.
\ Dan stoppen de leds met knipperen, omdat de cpu niet gereset wordt.
: DEMO          ( -- )
    SETUP  7 WATCHDOG-ON                \ Watchdog met cyclustijd van 1900 ms
    -1 SETDIR LEDS  0 SETDIR INGANG
    CLEAR LEDS 250 MS SET LEDS          \ Leds even aan
    BEGIN  
        FROM INGANG 0= IF               \ Is schakelaar PD0 ingedrukt ?
            RESET-WATCHDOG  $7F TO LEDS \ Ja, reset watchdog, led 7 aan
        THEN                            \ Nee, doe niets
        100 MS  SET LEDS  100 MS        \ En wacht even, led 7 uit
    AGAIN
    ;  MAIN

                               ( Einde )
