\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : Arrays in EEPROM
\ DESCRIPTION : Test CREATE op ROM en EEPROM arrays.
\ CATEGORY    : Applicatie, afmeting: 296 bytes.
\ AUTHOR      : Willem Ouwerkerk, December 31, 2001
\ LAST CHANGE : Willem Ouwerkerk, Januari 5, 2002
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel
NEEDS AVR-EEP.FRT


DOC  Over CREATE

De AVR gebruikt word (16-bits) adressen voor subroutines
en byte (8-bits) adressen in het Z-reg (LPM) om data uit 
het FLASH geheugen te lezen. De code voor CREATE en zijn
optimizers hielden daar geen rekening mee. Dit is nu
aangepast en definieerende woorden zijn nu ok. Ook was
er een verschil tussen de simulator en de echte AVR, dit
is ook weg gewerkt.

Ook is er een EEHERE en EEALLOT toegevoegd om het werken
met ingebouwd EEPROM te vereenvoudigen.

ENDDOC


:: EEVARS
    CREATE  EEHERE DROP C, ALIGN  EEALLOT   ( array-lengte -- )
    DOES>   ROM@ +                          ( element -- element-adres )
    ;

1. EEALLOT                                  ( Gebruik eerste byte in EE nooit )
8. EEVARS LIJN                              ( Reserveer EE-array van 8 bytes )

PORTB SFR LEDS

: TO-LEDS       ( bit-patr -- )
    INVERT TO LEDS
    ;

:MAIN
    -1 SETDIR LEDS
    250 MS  SET LEDS                        \ Toon opstarten
    128  8 0 DO                             \ Vul 8 bytes van EEPROM
        DUP I LIJN  DUP TO-LEDS 250 MS      \ Toon EEPROM adressen
        EE!  U2/                            \ Bewaar patroon en maak nieuw
    LOOP
    DROP
    BEGIN
        1  8 FOR                            \ Toon lopend licht op leds
            DUP TO-LEDS  100 MS  2*
        NEXT
        DROP  8 0 DO                        \ Toon patroon uit EE op leds
            I LIJN EE@  TO-LEDS  100 MS
        LOOP
    AGAIN
    ;

                              ( Einde )
