\ Lees ADC en schrijf naar DAC voor PCF8591 op adres 0 (456 bytes) = fl 14,50

90S2313
NEEDS TARGET.FRT
4 SET-CRYSTAL

NEEDS I2C-PRIM.FRT                      \ Laad bibliotheek files
NEEDS I2C-8574.FRT

$94     CONSTANT ADC-ID                 \ Adc identificatie adres

FLAG DAC?                               \ True als DAC ook actief moet blijven
                                        \ tijdens het inlezen van de ADC
: ADC           ( +n -- u )             \ Lees ingang +n van adc
    START-BIT
    ADC-ID BYTE-UIT                     \ Stuur chip adres schrijven
    3 AND  DAC? $40 AND  OR BYTE-UIT    \ Selecteer gewenste ingang
    START-BIT                           \ Geef 'repeated start' 
    ADC-ID 1+ BYTE-UIT                  \ Stuur chip adres lezen
    BYTE-IN  ACK-BIT  DROP              \ Gooi oude analoge waarde weg
    BYTE-IN  NACK-BIT                   \ Lees verse omzetting
    STOP-BIT                            \ Klaar
    ;

: DAC           ( u -- )                \ Stuur u naar dac
    START-BIT
    ADC-ID BYTE-UIT                     \ Stuur chip adres schrijven
    $40 BYTE-UIT                        \ Stuur controle byte en
    BYTE-UIT                            \ daarna de databyte
    STOP-BIT                            \ Klaar
    ;

: NAAR-LEDS     ( byte -- )             \ Stuur data naar PCF8574 op adres 0
    INVERT  $0F OR  I/O-ID1 !BYTE
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    255 NAAR-LEDS  250 MS
    0   NAAR-LEDS  250 MS
    ;

: ANALOOG       ( -- )                  \ Toon gebruik van ADC/DAC
    SETUP  SETUP-I2C  KNIPPER           \ Initialiseer I2C en toon opstarten
    SET DAC?                            \ DAC wordt gebruikt
    BEGIN
        0 ADC                           \ Lees ADC ingang 0
        DUP INVERT DAC                  \ en zet omgekeerde signaal op DAC
        U2/ U2/ U2/ U2/                 \ deel door 16
        4 LSHIFT NAAR-LEDS              \ Schaal in en zet op leds
    AGAIN
    ;  MAIN                             \ ANALOOG start op na een reset

\ Einde