
\ I2C uitvoer met een PCF8574 (310 bytes).

90S2313                                 \ Code draait op een 90S2313
NEEDS TARGET.FRT                        \ Laad systeem constanten

\ I2C primitieven voor een 4 MHz kristal

PORTD SFR DATA
PORTB SFR LEDS
PORTD 4 BIT-SFR SDA                     \ Serieele data lijn
PORTD 5 BIT-SFR SCL                     \ Serieele klok lijn
$40 CONSTANT I/O-ID                     \ Device adres 0 van gebruikte chip

\ Algemene I2C primitieven

: WACHT          ( -- )                 \ Wacht 4.75 us
    2 FOR  NEXT
    ;

: SETUP-I2C      ( -- )                 \ Setup I2C I/O bits
    0 SETDIR DATA  0 TO DATA
    ;

: START-BIT     ( -- )                  \ Genereer startbit
    0 SETDIR SDA  0 SETDIR SCL
    1 SETDIR SDA  WACHT  
    1 SETDIR SCL  WACHT
    ;

: STOP-BIT      ( -- )                  \ Genereer stopbit
    1 SETDIR SDA  0 SETDIR SCL  WACHT  0 SETDIR SDA
    ;

: ACK?          ( -- vlag )             \ Test binnenkomend ackbit, vlag is
    0 SETDIR SDA  0 SETDIR SCL  WACHT  
    FROM SDA 0=  1 SETDIR SCL  WACHT    \ true als er een ack ontvangen is
    ;

: BYTE-UIT      ( byte -- )             \ Stuur byte en test ack
    8 FOR
\       DUP 128 AND  0= SETDIR SDA  2*
        DUP 128 AND IF 0 SETDIR SDA ELSE 1 SETDIR SDA THEN  2*
        0 SETDIR SCL  WACHT  1 SETDIR SCL  WACHT
    NEXT
    DROP  ACK? 0= IF  STOP-BIT  THEN    \ Geen ack, genereer dan een stopbit
    ;

\ Uitvoer routine voor PCF8574(a) chips

: !BYTE         ( byte chip -- )
    START-BIT
    $FE AND BYTE-UIT                    \ Stuur schrijfadres naar chip en
    BYTE-UIT                            \ daarna de databyte
    STOP-BIT                            \ Klaar
    ;

\ Onze eerste I2C toepassing een looplicht

: NAAR-LEDS     ( byte -- )             \ Stuur data naar PCF8574 op adres 0
    INVERT  ( DUP TO LEDS )
    $0F OR  I/O-ID !BYTE                \ De lage 4 bits zijn altijd hoog
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    255 NAAR-LEDS  250 MS
    0   NAAR-LEDS  250 MS
    ;

: LOOPLICHT     ( -- )                  \ Toon een looplicht op de leds
    SETUP  ( -1 SETDIR LEDS )
    SETUP-I2C  KNIPPER  
    BEGIN
        4 0 DO
            1 I 4 + LSHIFT NAAR-LEDS    \ Zet een led aan
            100 MS                      \ Wacht 100 millisec.
        LOOP
    AGAIN
    ;  MAIN                             \ LOOPLICHT start op na een reset
