\ Universele kwis aansturing voor 2 tot 6 deelnemers
\ Naam      : KWIS2.FRT
\ Lengte    : 216 Bytes
\ Gemaakt   : 18-01-97, Willem Ouwerkerk
\ Gewijzigd : 30-06-03, Willem Ouwerkerk
\ Doel      : Universele kwis aansturings software
\ Poort-B bit 0 t/m 5 zijn uitvoer bits, bit 7 is de buzzer.
\ Poort-D bit 0 t/m 5 zijn invoer bits, bit 7 is reset.

90S2313  2 0 0 MEMORY               \ Kies CPU en geheugen gebruik
NEEDS TARGET                        \ Laad labels

PORTB   SFR UITVOER                 \ Kandidaten lampen & buzzer (PB)
PORTB 7 BIT-SFR BUZZER              \ Buzzer schakel bit (PB.7)
PORTD   SFR INVOER                  \ Invoer van kandidaten (PD)
PIND 7 BIT-SFR MASTER?              \ Invoer van kwis master (PD.7)

3 CONSTANT #KANDIDATEN              \ Aantal kandidaten mag 2 tot 6
                                    \ zijn en is hier 3 !!!
: KANDIDAAT     ( -- kandidaat )    \ Test wie gedrukt heeft
    #KANDIDATEN 0 DO
        FROM INVOER INVERT          \ Lees invoer
        1 I LSHIFT  AND ?DUP        \ Test kandidaat drukknop
        IF  UNLOOP  EXIT  THEN      \ Geef kandidaat nummer
    LOOP
    0                               \ Geen kandidaat
    ;

: WACHT-EVEN    ( -- )              \ Wacht max. 10 seconden
    100 0 DO
        100 MS                      \ of tot de kwismaster
        MASTER? 0= IF  LEAVE  THEN  \ tussenbeide komt
    LOOP
    ;

: TOON-KANDIDAAT ( kandidaat -- )   \ Zet lamp aan bij een
    ?DUP IF                         \ kandidaat die gedrukt heeft
        INVERT TO UITVOER           \ zet zijn lamp aan
        CLEAR BUZZER  150 MS        \ Buzzer 150 millisec. aan
        SET BUZZER                  \ Buzzer uit
        WACHT-EVEN  SET UITVOER     \ Wacht en zet lamp uit
    THEN
    ;

: KWIS-MASTER       ( -- )          \ Een kwis met 2 tot 6 personen
    SETUP-BYTEFORTH                 \ Stel Forth tevreden,
    -1 SETDIR UITVOER               \ maak uitgangen actief,
    0 SETDIR INVOER                 \ ingangspoort actief en
    CLEAR UITVOER                   \ zet de lampen en buzzer even aan
    250 MS                          \ laat dat even zo en
    SET UITVOER                     \ zet alles weer uit.
    BEGIN
        KANDIDAAT                   \ Test kandidaat toetsen
        TOON-KANDIDAAT              \ en toon resultaat
    AGAIN
    ;  MAIN

\ Einde
