\ -----------------------------------------------------------
\ PROJECT     : I2C thermometer met LM75CIM, 546 bytes
\ AUTEUR      : Willem Ouwerkerk, November 26, 1999
\ -----------------------------------------------------------

90S2313                             \ Select target
NEEDS TARGET.FRT                    \ Load target specific constants
NEEDS RS232.FRT                     \ Load RS232 library
NEEDS I2C-PRIM.FRT                  \ Load I2C primitive library
4 SET-CRYSTAL                       \ Set used Xtal

$90 CONSTANT LM75-ID                \ LM75 base address

: SELECT-CHIP   ( chip -- dev-id )  \ Max. 8 LM75 chips
    7 AND 2*  LM75-ID  + ;

: TEMPERATUUR   ( chip -- u )       \ Read temperature as
    START-BIT                       \ an 8 bit value
    SELECT-CHIP  1 OR  BYTE-UIT
    BYTE-IN  ACK-BIT                \ msb
    BYTE-IN  NACK-BIT  DROP         \ Throw lsb away
    STOP-BIT ;

\ Define high level control for LM75

: SECONDEN      ( u -- )            \ Wait u seconds
    FOR  4 FOR  250 MS  NEXT  NEXT
    ;

PORTB SFR LEDS

: THERMOMETER   ( -- )
    SETUP  SETUP-I2C                \ Start Forth machine
    RS232-SETUP  -1 SETDIR LEDS     \ Initialise RS232 at 9600 baud
    CLEAR LEDS  1 SECONDEN
    SET LEDS    1 SECONDEN
    BEGIN
            5 SECONDEN              \ Wait a moment
            0 TEMPERATUUR  DUP EMIT \ Read LM75 en send binary to RS232
            INVERT  TO LEDS
    AGAIN ;  MAIN                   \ Set startup vector

                               ( End )