\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth
\ PROJECT     : Demonstratie software
\ DESCRIPTION : Looplicht op poort B
\ CATEGORY    : Applicatie, afm: 114 bytes.
\ AUTHOR      : Willem Ouwerkerk, Oktober 22, 1999
\ LAST CHANGE : Willem Ouwerkerk, Februari 4, 2000
\ ----------------------------------------------------------------------

90S2313                                 \ Compileer voor AT90S2313
NEEDS TARGET.FRT                        \ Laad labels & vectoren voor 90S2313
ATOM MS                                 \ Import MS as word

DDRB    SFR DIRB                        \ Poort B richtings register
PORTB   SFR LEDS                        \ Poort B met 8 leds

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    0 TO LEDS   250 MS                  \ Alle leds aan
    -1 TO LEDS  250 MS                  \ Alle leds uit
    ;

: LOOPLICHT     ( -- )
    SETUP                               \ Installeer Forth machine
    SET DIRB                            \ Poort B wordt gebruikt als uitgang
    KNIPPER
    BEGIN
        1  8 FOR                        \ Doe lus acht maal
            DUP INVERT TO LEDS  2*      \ Keer om en stuur de leds aan
            100 MS                      \ Wacht even
        NEXT  DROP
    AGAIN                               \ Begin weer opnieuw
    ;  MAIN                             \ LOOPLICHT start op na een reset

                               ( End )
