\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth
\ PROJECT     : Demonstratie software voor megaAVR
\ DESCRIPTION : Looplicht op poort B
\ CATEGORY    : Applicatie, afm: 98 bytes tegen 62 op een 8051.
\ AUTHOR      : Willem Ouwerkerk, Oktober 22, 1999
\ LAST CHANGE : Willem Ouwerkerk, Mei 18, 2000
\ ----------------------------------------------------------------------

mega103                                 \ Compileer voor ATmega103
2 0 0 MEMORY                            \ Adjust memory layout
NEEDS TARGET.FRT                        \ Laad labels & vectoren voor CPU
ATOM MS                                 \ Import MS as word

PORTB   SFR LEDS                        \ Poort B met 8 leds

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    0 TO LEDS   250 MS                  \ Alle leds aan
    -1 TO LEDS  250 MS                  \ Alle leds uit
    ;

:MAIN           ( -- )
    -1 SETDIR LEDS                      \ Poort B wordt gebruikt als uitgang
    KNIPPER
    BEGIN
        1  8 FOR                        \ Doe lus acht maal
            DUP INVERT TO LEDS  2*      \ Keer om en stuur de leds aan
            100 MS                      \ Wacht even
        NEXT  DROP
    AGAIN                               \ Begin weer opnieuw
    ;                                   \ LOOPLICHT start op na een reset

                               ( End )
