\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : MEGA-PBM.FRT
\ DESCRIPTION : Pulsbreedte modulatie op zijn megaAVR's
\ CATEGORY    : Voorbeeld, afmeting: 244 bytes.
\ AUTHOR      : Willem Ouwerkerk, March 05, 2000
\ LAST CHANGE : Willem Ouwerkerk, March 05, 2000
\ ----------------------------------------------------------------------

mega103                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

TCCR1A SFR T1-CONTROLA                  \ Bestuur timer 1
TCCR1B SFR T1-CONTROLB
OCR1AL SFR POWER1
OCR1BL SFR POWER2
PORTB 5 BIT-SFR PBM1
PORTB 6 BIT-SFR PBM2


: SETUP-PBM         ( -- )
    $A1 TO T1-CONTROLA                  \ 8 bit PBM & normale PBM
    $01 TO T1-CONTROLB                  \ Gebruik CPU klok
    1 SETDIR PBM1                       \ OCR1A (PB.5) is uitgang
    1 SETDIR PBM2                       \ OCR1B (PB.6) is uitgang
    CLEAR POWER1  CLEAR POWER2          \ PBM = 0
    ;

\ Demonstratie van het gebruik

: 10MS              ( u -- )            \ Wacht u maal 10 millisec.
    FOR  10 MS  NEXT
    ;

: DEMO              ( -- )
    SETUP  SETUP-PBM  255 10MS          \ Start op nul, wacht even
    BEGIN
        255 FOR                         \ Doorloop alle PBM standen
            I' TO POWER1
            255 I' - TO POWER2  2 10MS
        NEXT
        255 FOR                         \ Doorloop alle PBM standen
            I' TO POWER2
            255 I' - TO POWER1  2 10MS
        NEXT
    AGAIN
    ;  MAIN

                               ( End )
