\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth
\ PROJECT     : Demonstratie software
\ DESCRIPTION : Looplicht op poort B
\ CATEGORY    : Applicatie, afm: 286 bytes.
\ AUTHOR      : Willem Ouwerkerk, Oktober 22, 1999
\ LAST CHANGE : Willem Ouwerkerk, Mei 19, 2000
\ ----------------------------------------------------------------------

mega103                                 \ Compileer voor ATmega103
NEEDS TARGET.FRT                        \ Laad labels & vectoren voor AVR

DDRB    SFR DIRB                        \ Poort B richtings register
PORTB   SFR LEDS                        \ Poort B met 8 leds
PIND    SFR INGANG                      \ Ingang met 8 schakelaars

: 10MS          ( u - )                 \ Wacht u maal 10 millisec.
    ?DUP IF  0 DO  10 MS  LOOP  THEN
    ;

: WACHT         ( -- )                  \ Wacht 0 tot 1270 millisec.
    INGANG INVERT                       \ Schakelaars zitten aan de massa
    10MS                                \ Wacht ingang * 10 millesec.
    ;

: NAAR-LEDS     ( x -- )                \ Zet x op leds
    INVERT  TO LEDS                     \ Inverteer x en stuur leds aan
    ;

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    -1 NAAR-LEDS    250 MS              \ Alle leds aan
    0 NAAR-LEDS     250 MS              \ Alle leds uit
    ;

: LOOPLICHT     ( -- )
    SETUP                               \ Installeer Forth machine
    SET DIRB                            \ Poort B wordt gebruikt als uitgang
    KNIPPER
    BEGIN
        8 0 DO                          \ Doe lus acht maal
            1 I LSHIFT                  \ Maak bitpatroon
            NAAR-LEDS                   \ Zet patroon op de leds
            WACHT                       \ Wacht even
        LOOP
    AGAIN                               \ Begin weer opnieuw
    ;  MAIN                             \ LOOPLICHT start op na een reset

                               ( End )
