\ -----------------------------------------------------------
\ PROJECT     : RS232 example for AVR, 2xx bytes
\ AUTEUR      : Willem Ouwerkerk, May 20, 2000
\ Tip         : EMIT structure, Jack Tidwell (AVR mailinglist)
\ -----------------------------------------------------------

UDR   SFR RS232-BUFFER
USR 7 BIT-SFR KEY?  ( -- flag )     \ True als ontvang buffer vol is
USR 5 BIT-SFR EMIT? ( -- flag )     \ True als zender nog bezig is

CODE RS232-SETUP                    \ RS232
    R16 25 LDI,                     \ Selecteer 9600 baud
    UBRR R16 OUT,
    R16 $18 LDI,
    UCR R16 OUT,                    \ RS232 ontvanger en zender aan
    RET,                            
END-CODE


: EMIT          ( char -- )         \ Stuur karakter via RS232
    BEGIN  PAUSE  EMIT? UNTIL
    TO RS232-BUFFER
    ;

: TYPE          ( a u -- )          \ Stuur ROM string via RS232
    FOR
        COUNT EMIT
    NEXT
    2DROP
    ;

: PAGE          ( -- )      ^L EMIT ;
: CR            ( -- )      ^M EMIT  ^J EMIT ;


: KEY           ( -- char )             \ Ontvang karakter via RS232
    BEGIN  PAUSE  KEY? UNTIL
    RS232-BUFFER
    ;


\ The AVR RS232 demo

FLAG SCHAKELAAR                         \ Bit geheugen ....

: RS232DEMO         ( -- )
    ." Demo "
    BEGIN
        CR  250 MS3                     \ New line & wait
        128 32 DO
            I EMIT  25 MS3              \ Send ASCII chars to RS232, than wait
        LOOP
    KEY? UNTIL
    ;

: WISSEL            ( -- )
    ." Wissel "  TOGGLE SCHAKELAAR
    ;

: BEHANDEL-INVOER   ( -- )              \ Handel karakter invoer af
    BEGIN
        CR ." > " KEY
        DUP &A = IF  ." Aap "   THEN
        DUP &B = IF  ." Boef "  THEN
        DUP &C = IF  ." Chip "  THEN
        DUP &D = IF  RS232DEMO  THEN
        DUP &W = IF  WISSEL     THEN
    &Q = UNTIL
    ;

: RS232         ( -- )                  \ Print message on top of screen
    BEGIN
        PAGE ." AVR Round Robin RS232 demo"
        BEHANDEL-INVOER
    AGAIN ;

                               ( Einde )
