\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : PBM met timer 0
\ DESCRIPTION : Puls breedte modulator met timer-0
\ CATEGORY    : Applicatie, afmeting: 248 bytes.
\ AUTHOR      : Willem Ouwerkerk, November 11, 2000
\ LAST CHANGE : Willem Ouwerkerk, November 11, 2000
\ ----------------------------------------------------------------------

90S8515                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

TCCR0 SFR TIMER-CONTROLE0               \ Hardware registers
TCNT0 SFR COUNTER0
TIMSK SFR TIMER-INT

#50 CONSTANT CYCLUS                     \ PBM Lengte
REGISTER PERIODE                        \ PBM Duur
REGISTER AANPULS                        \ PBM aantijd
REGISTER AANTIJD                        \ PBM werkregister
PORTB 0 BIT-SFR UITGANG                 \ PB.0

: SETUP-PBM         ( -- )              \ Stel PBM in op 400 Hz
    CYCLUS TO PERIODE
    56 TO COUNTER0
    2 TO TIMER-INT
    1 TO TIMER-CONTROLE0
    INTERRUPT-ON
    ;

\ Ongeveer 25 cycles van elke 200 wordt voor PBM gebruikt = 12.5 %
CODE PBM            ( -- )              \ PBM opwekking
    R16 PUSH,
    R16 56 LDI,
    TCNT0 R16 OUT,
    ADR AANTIJD TST,                    \ Aantijd verstreken ?
    ZER IF,
        ADR UITGANG CBI,                \ Ja, uitgang laag !
    ELSE,
        ADR UITGANG SBI,                \ Nee, uitgang hoog en verlaag aantijd
        ADR AANTIJD DEC,
    THEN,
    ADR PERIODE DEC,                    \ Cyclus verstreken ?
    ZER IF,
        ADR AANTIJD ADR AANPULS MOV,    \ Ja, zet aantijd in werkregister
        R16 CYCLUS LDI,                 \ en stel cyclusduur in
        ADR PERIODE R16 MOV,
    THEN,
    R16 POP,
    RETI,
END-CODE  T0-OVERFLOW

: SNELHEID          ( u -- )            \ Zet snelheid van 0 to 50
    CYCLUS UMIN  TO AANPULS
    ;

: PBM-DEMO          ( -- )
    SETUP  
    -1 SETDIR UITGANG
    CLEAR UITGANG   255 MS
    SET UITGANG     255 MS
    SETUP-PBM
    BEGIN
        CYCLUS FOR
            I' SNELHEID  100 MS
        NEXT
        0 SNELHEID
        2 FOR  250 MS  NEXT
        50 SNELHEID
        2 FOR  250 MS  NEXT
    AGAIN
    ;  MAIN

                              ( Einde )
