\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : PBM met timer 0
\ DESCRIPTION : Puls breedte modulator met timer-0
\ CATEGORY    : Applicatie, afmeting: 208 bytes.
\ AUTHOR      : Willem Ouwerkerk, April 8, 2002
\ LAST CHANGE : Willem Ouwerkerk, Juli 22, 2002
\ ----------------------------------------------------------------------

90S2313                                 \ Selecteer target
NEEDS TARGET.FRT                        \ Laad cpu specifiek deel

TCCR0 SFR TIMER-CONTROLE0               \ Hardware registers
TCNT0 SFR COUNTER0
TIMSK SFR TIMER-INT

#50 CONSTANT CYCLUS                     \ PBM Lengte
REGISTER AANTIJD                        \ PBM aantijd
REGISTER UITTIJD                        \ PBM uittijd
PORTB 0 BIT-SFR UITGANG                 \ PB.0

: SETUP-PBM         ( -- )              \ Stel PBM in
    -1 TO COUNTER0
    2 TO TIMER-INT                      \ Activeer timer-int 0
    2 TO TIMER-CONTROLE0                \ Zet timer-0 prescaler op xt/8
( ) INTERRUPT-ON
    ;

\ Ongeveer 28 cycles van elke 400 wordt voor PBM gebruikt = 7 %
\ De frequentie is 4.000.000/8 ~ 500.000/50 ~ 10 kHz
\ Deze methode regelt van ~ 2% tot 98 %
CODE PBM            ( -- )              \ PBM opwekking
    ADR UITGANG SBIS,                   \ Uitgang hoog ?
    AHEAD,
        TCNT0 ADR UITTIJD OUT,          \ Ja, zet pulslengte laag
        ADR UITGANG CBI,                \ en de uitgang laag
        RETI,
    THEN,
    TCNT0 ADR AANTIJD OUT,              \ Nee, zet pulslengte hoog
    ADR UITGANG SBI,                    \ en de uitgang hoog
    RETI,
END-CODE  T0-OVERFLOW

: SNELHEID          ( u -- )            \ Zet snelheid van 0 to 50
    1+ CYCLUS 1- UMIN
    DUP NEGATE TO AANTIJD
    CYCLUS - TO UITTIJD
    ;

: PBM-DEMO          ( -- )
    SETUP  
    -1 SETDIR UITGANG
    CLEAR UITGANG   255 MS
    SET UITGANG     255 MS
    SETUP-PBM
    BEGIN
        CYCLUS FOR
            I' SNELHEID  100 MS
        NEXT
        CYCLUS SNELHEID
        4 FOR  250 MS  NEXT
        0 SNELHEID
        4 FOR  250 MS  NEXT
    AGAIN
    ;  MAIN

                              ( Einde )
