\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : RANDOM.FRT
\ DESCRIPTION : Genereer pseudo random getallen van 8 tot 40 bits
\ CATEGORY    : Applicatie, afmeting: 46 bytes.
\ AUTHOR      : Willem Ouwerkerk, April 02, 2000
\ LAST CHANGE : Willem Ouwerkerk, April 02, 2000
\ ----------------------------------------------------------------------

\ 90S2313                               \ Selecteer target
\ NEEDS TARGET.FRT                      \ Laad cpu specifiek deel

DOC umentatie over schuifregisters als random generator

Schuifregister waarvan de uitgangen genummerd zijn van 1 t/m 'm'
en de uitgangen 'm' en 'n' geXORed worden en het resultaat 
daarvan weer op bit 1 ingevoerd wordt.

    m   n   cyclus-lengte       woordlengte
 ---------------------------------------------
    3   2       7
    4   3       15                  4 bits
    5   3       31
    6   5       63
    7   6       127                 8 bits
    9   5       511
   10   7       1023
   11   9       2047
   15  14       32767               16 bits
   17  14       131071
   18  11       262143
   20  17       1048575
   23  18       8388607             24 bits
   31  28       2147486347          32 bits
   39  35       549755813887        40 bits

    m       n       cyclus-lengte   woordlengte
 -------------------------------------------------
    8     4,5,6         255             8 bits
   16    4,13,15        65535           16 bits
   24   17,22,23        16777215        24 bits

Als voorbeeld een generator met een (m) 7 bits cyclus.

ENDDOC

REGISTER SEED                           \ Werkplek voor random generator

CODE RANDOM     ( -- )                  \ Maak een pseudo random getal
    R16 ADR SEED MOV,                   \ met een 7 bits cyclus
    R16 LSL,
    R17 R16 MOV,
    R17 LSL,
    R16 R17 EOR,
    R16 LSL,
    ADR SEED ROL,
    RET,
END-CODE

: CHOOSE        ( u1 -- 0 to u1-1 )     \ Maak 'random' getal tussen 0 en u1-1
    RANDOM  SEED UM* NIP
    ;

                              ( Einde )
