\ -----------------------------------------------------------
\ PROJECT     : RS232 example for AVR, 286 bytes
\ AUTEUR      : Willem Ouwerkerk, Juli 28, 2000
\ Tip         : EMIT structure, Jack Tidwell (AVR mailinglist)
\ -----------------------------------------------------------

90S2313                             \ Select target
NEEDS TARGET.FRT                    \ Load target specific constants
4 SET-CRYSTAL                       \ Set used Xtal

CODE RS232-SETUP                    \ RS232
    R16 25 LDI,                     \ Select 9600 baud
    UBRR R16 OUT,
    R16 $18 LDI,
    UCR R16 OUT,                    \ Enable receiver & transmitter
    RET,                            \ Reset interrupt, set 8 bit data.
END-CODE

CODE EMIT       ( char -- )         \ RS232 Char to RS232
    R16 X+ LD,
    BEGIN,
        USR 5 SBIS,
    AGAIN,
    UDR R16 OUT,
    RET,
END-CODE

: TYPE          ( a u -- )          \ RS232 type string from ROM
    FOR
        2DUP ROM@ EMIT  1 M+
    NEXT
    2DROP
    ;

: PAGE          ( -- )      ^L EMIT ;
: CR            ( -- )      ^M EMIT  ^J EMIT ;


\ The AVR RS232 demo

ATOM INLINE$                        \ Fetch inline string from ROM

PORTB SFR LEDS                      \ Leds on STK200 board

: RS232-DEMO    ( -- )
    SETUP                           \ Initialize Forth machine
    RS232-SETUP                     \ Initialise RS232 at 4800 baud
    -1 SETDIR LEDS
    CLEAR LEDS  250 MS              \ Flash leds to signal startup
    SET LEDS 250 MS
    PAGE  ." AVR RS232 demo "       \ Print message on top os screen
    BEGIN
        CR  250 MS                  \ New line & wait
        128 32 DO   
            I EMIT                  \ Send ASCII chars to RS232
            I TO LEDS  100 MS       \ and to LEDS, then wait a moment.
        LOOP
    AGAIN ;  MAIN                   \ Set startup vector

                               ( Einde )
