\ ==============================================================
\ [TITLE]     AVR ByteForth TLC549IP AD code
\ [FILE]      ADC549IP.FRT
\ [CATEGORY]  Library ( 76 bytes )
\ [VSN]       1.01 
\ [CREATED]   April 30, 1995, Willem Ouwerkerk 
\ [LASTCHNGD] March 3, 2000, Willem Ouwerkerk 
\ [COPYRIGHT] De Elektrise Schaar (C) 1995-2000
\ [USES]      AVR ByteForth cross compiler
\ [PURPOSE]   Eight bit serial AD Converter, with a faster
\             klok than 4MHz, adc-klok must be stretched.
\ ==============================================================

PORTD 3 BIT-SFR ADC-KLOK                \ ADC klokpuls invoer
PORTD 4 BIT-SFR ADC-DATA                \ ADC data uitvoer
PORTD 5 BIT-SFR ADC-SELECTEER           \ ADC activeer/selecteer invoer

\G Initialiseer de ADC interface.
: SETUP-ADC         ( -- )              \ ADC549IP  "setup-a-d-c"  activeer I/O richting
    1 SETDIR ADC-KLOK                   \ Uitvoer
    0 SETDIR ADC-DATA                   \ Invoer
    1 SETDIR ADC-SELECTEER              \ Uitvoer
    ;

\G Lees de ADC ingang, 'u' is het resultaat van deze conversie.
: ADC               ( -- u )            \ ADC549IP  "a-d-c"  Lees laatste ADC omzetting
    CLEAR ADC-KLOK                      \ Stop het lezen van de invoer
    SET ADC-SELECTEER                   \ Start ADC omzetting
    19 FOR NEXT                         \ Conversie duurt max. 17 us 
    CLEAR ADC-SELECTEER
    FROM ADC-DATA 1 AND                 \ Lees data
    7 FOR                               \ Data bestaat uit 8 bits
        SET ADC-KLOK
        CLEAR ADC-KLOK                  \ Schuif volgend bit naar buiten
        2*  FROM ADC-DATA  1 AND  OR    \ Schaal data in en lees volgend bit
    NEXT
    SET ADC-KLOK
    ;

\ Einde
