\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : AVR-EEP.FRT
\ DESCRIPTION : Gebruik van de interne AVR EEPROM
\ CATEGORY    : Bibliotheek, afmeting: xxx bytes.
\ AUTHOR      : Willem Ouwerkerk, Juli 05, 2000
\ LAST CHANGE : Willem Ouwerkerk, Juli 05, 2000
\ ----------------------------------------------------------------------

EESIZE nip 1 U> [IF]

EESIZE 2CONSTANT EEMAX                  \ Double EEPROM size
EEARL SFR LAAG                          \ EEPROM adres register laag
EEARH SFR HOOG                          \ EEPROM adres register hoog
EEDR SFR DATA                           \ EEPROM data register
EECR 0 BIT-SFR LEES                     \ EEPROM lees opdracht
EECR 1 BIT-SFR SCHRIJF                  \ EEPROM schrijf opdracht
EECR 2 BIT-SFR BEVEILIG                 \ EEPROM schrijf beveiliging opdracht

\G Lees van EEPROM adres 'da' de byte 'x'.
\G Er is ook een versie voor EEPROM met een single adres 'a'.
: EE@           ( da -- x )
    TO HOOG  TO LAAG                    \ Zet adres reg.
    SET LEES                            \ Lees data op dat adres
    BEGIN  LEES 0= UNTIL                \ Wacht tot data gelezen is
    DATA                                \ Data op stack
    ;

\G Schrijf naar EEPROM adres 'da' de byte 'x'.
\G Er is ook een versie voor EEPROM met een single adres 'a'.
: EE!           ( x da -- )
    BEGIN  SCHRIJF 0= UNTIL             \ Vorige schrijf opdr. afgerond
    TO HOOG  TO LAAG  TO DATA           \ Ja, zet adres en data klaar
    SET BEVEILIG  SET SCHRIJF           \ geef schrijf opdracht
    ;

[ELSE]

EESIZE drop CONSTANT EEMAX              \ Single EEPROM size
EEAR SFR ADRES                          \ EEPROM adres register
EEDR SFR DATA                           \ EEPROM data register
EECR 0 BIT-SFR LEES                     \ EEPROM lees opdracht
EECR 1 BIT-SFR SCHRIJF                  \ EEPROM schrijf opdracht
EECR 2 BIT-SFR BEVEILIG                 \ EEPROM schrijf beveiliging opdracht

: EE@           ( a -- x )
    TO ADRES                            \ Zet adres reg.
    SET LEES                            \ Lees data op dat adres
    BEGIN  LEES 0= UNTIL                \ Wacht tot data gelezen is
    DATA                                \ Data op stack
    ;

: EE!           ( x a -- )
    BEGIN  SCHRIJF 0= UNTIL             \ Vorige schrijf opdr. afgerond
    TO ADRES  TO DATA                   \ Ja, zet adres en data klaar
    SET BEVEILIG  SET SCHRIJF           \ geef schrijf opdracht
    ;

[THEN]

                              ( Einde )