\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth vsn 2.00
\ PROJECT     : CP-ADC.FRT
\ DESCRIPTION : Probeer ADC via comparator
\ CATEGORY    : Voorbeeld, afmeting: 54 bytes.
\ AUTHOR      : Willem Ouwerkerk, Mei 29, 2003
\ LAST CHANGE : Willem Ouwerkerk, Mei 29, 2003
\ ----------------------------------------------------------------------

PORTB 2 BIT-SFR COMP+                   \ Comparator in- en uitgang(en)
PORTB 3 BIT-SFR COMP-
ACSR 5  BIT-SFR COMP-UIT

: ONTLAAD-CONDENSATOR   ( -- )
    1 SETDIR COMP+  1 /MS               \ PB2 100 us laag
    ;

\G PB2 en 3 zijn hoogohmige ingangen.
: SETUP-ADC             ( -- )          \ Cp-adc "setup-a-d-c"
    CLEAR COMP-  CLEAR COMP+            \ Schakel pullups uit
    0 SETDIR COMP-  0 SETDIR COMP+      \ PB2 & PB3 zijn ingang
    ;

\ Zeven kloktikken per omzetting = 1.75 us per stap bij 4 MHz.
\ u is de omzettingstijd, dit is een maat voor de spanning op COMP-
CODE LAAD-CONDENSATOR   ( -- u )
    DDRB 2 CBI,                         \ COMP+ is ingang zonder pullup
    R16 CLR,                            \ Resultaat is nul
    BEGIN,
        NOP, NOP,
        R16 INC,                        \ Verhoog resultaat
    NZR WHILE,                          \ Stop als resultaat groter dan 255 is
        ADR COMP-UIT SBIS,              \ COMP+ groter dan COMP- ?
    REPEAT,
    R16 DEC,                            \ Klaar en corrigeer resultaat
    DDRB 2 SBI,                         \ COMP+ is lage uitgang (ontlaad C)
    -X R16 ST,                          \ Resultaat op datastack
    RET,
END-CODE

\G Bepaal de analoge spanning op PB3, 'u' is het resultaat.
: ADC                   ( -- u )        \ Cp-adc "a-d-c"
    ONTLAAD-CONDENSATOR  LAAD-CONDENSATOR
    ;

                              ( Einde )
