\ I2C routines om in een 24C01 EEPROM te lezen en schrijven (163 bytes) = 4,95
\ Heeft I2C-PRIM.FRT nodig uit de bibliotheek ( LIB ).

$A0 CONSTANT EEPROM-ID                  \ EEPROM identificatie adres

\ Lees de data x vanaf het EEPROM adres addr. ByteForth
\ heeft ook library's voor de: 24C01 en de 24C02.
: LEES-BYTE     ( addr -- x )           \ Lees een byte x uit addr in EEPROM
    START-BIT
    EEPROM-ID BYTE-UIT                  \ Stuur chip adres voor schrijven
    BYTE-UIT                            \ Stuur EEPROM leesadres
    START-BIT                           \ Geef herhaalde start conditie
    EEPROM-ID 1+ BYTE-UIT               \ Stuur chip adres voor het lezen
    BYTE-IN             NACK-BIT        \ van data uit het EEPROM adres
    STOP-BIT
    ;

\ Schrijf de data x naar het EEPROM adres addr. ByteForth
\ heeft ook library's voor de: 24C01 en de 24C02.
: SCHRIJF-BYTE  ( x addr -- )           \ Schrijf byte x naar EEPROM
    BEGIN
        START-BIT  EEPROM-ID (BYTE-UIT)
    ACK? UNTIL                          \ Wacht op ackbit
    BYTE-UIT  BYTE-UIT  STOP-BIT        \ Stuur adres en databyte
    ;

\ Einde