\ I2C routines om in een 24C04 EEPROM te lezen en schrijven (181 bytes) = 2,95
\ Heeft I2C-PRIM.FRT nodig uit de bibliotheek ( LIB ).

$A0 CONSTANT EEPROM-ID                  \ EEPROM identificatie adres

: LEES-BYTE     ( d-adres -- byte )     \ Lees een byte op d-adres uit EEPROM
    START-BIT
    OVER 1 AND 2*  EEPROM-ID  OR >R     \ Maak pagina nr
    R@ BYTE-UIT                         \ Stuur chip adres voor schrijven
    DU2/ DROP  BYTE-UIT                 \ Stuur EEPROM leesadres
    START-BIT                           \ Geef herhaalde start conditie
    R> 1+ BYTE-UIT                      \ Stuur chip adres voor het lezen
    BYTE-IN             NACK-BIT        \ van data uit het EEPROM adres
    STOP-BIT
    ;

: SCHRIJF-BYTE  ( byte d-adres -- )     \ Schrijf byte naar d-adres in EEPROM
    OVER 1 AND 2*  EEPROM-ID  OR        \ Maak EEPROM device adres
    BEGIN
        START-BIT  DUP (BYTE-UIT)
    ACK? UNTIL                          \ Wacht op ackbit
    DROP  DU2/ DROP                     \ Verwijder device adres
    BYTE-UIT  BYTE-UIT  STOP-BIT        \ Stuur adres en databyte
    ;

\ Einde