\ I2C routines om in een 24C08 EEPROM te lezen en schrijven (64 bytes) = 5,50
\ Heeft I2C-PRIM.FRT nodig uit de bibliotheek ( LIB ).

$A0 CONSTANT EEPROM-ID                  \ EEPROM identificatie adres

: LEES-BYTE     ( d-adres -- byte )     \ Lees een byte op d-adres uit EEPROM
    START-BIT
    OVER  3 AND 2*  EEPROM-ID  OR >R    \ Maak pagina nr. en voeg samen met
    R@ BYTE-UIT                         \ chip device adres
    DU2/ DU2/ DROP  BYTE-UIT            \ Stuur EEPROM leesadres
    START-BIT                           \ Geef herhaalde start conditie
    R> 1+ BYTE-UIT                      \ Stuur device adres voor het lezen
    BYTE-IN             NACK-BIT        \ van data uit het EEPROM d-adres
    STOP-BIT
    ;

: SCHRIJF-BYTE  ( byte d-adres -- )     \ Schrijf byte naar d-adres in EEPROM
    OVER 3 AND 2*  EEPROM-ID  OR        \ Maak EEPROM device adres
    BEGIN
        START-BIT  DUP (BYTE-UIT)
    ACK? UNTIL                          \ Wacht op ackbit
    DROP  DU2/ DU2/ DROP                \ Verwijder device adres, maak adres
    BYTE-UIT  BYTE-UIT  STOP-BIT        \ Stuur adres laag en databyte
    ;

\ Einde