\ I2C routines om in een 24C16 EEPROM te lezen en schrijven (64 bytes) = 4,50
\ Heeft I2C-PRIM.FRT nodig uit de bibliotheek ( LIB ).

$A0 CONSTANT EEPROM-ID                  \ EEPROM identificatie adres

\G Lees de data 'x' vanaf het dubbele EEPROM adres 'addr'. ByteForth
\G heeft ook library's voor de: 24C04, 24C08 en de 24C16.
: LEES-BYTE     ( d-addr -- x )         \ I2C24C16 Lees een byte op d-adres uit EEPROM
    START-BIT
    OVER 7 AND 2*  EEPROM-ID  OR >R     \ I2C24C16 Maak pagina nr. en voeg samen met
    R@ BYTE-UIT                         \ chip device adres
    DU2/ DU2/ DU2/ DROP BYTE-UIT        \ Stuur EEPROM leesadres
    START-BIT                           \ Geef herhaalde start conditie
    R> 1+ BYTE-UIT                      \ Stuur device adres voor het lezen
    BYTE-IN  NACK-BIT                   \ van data uit het EEPROM d-adres
    STOP-BIT
    ;

\G Schrijf de data 'x' naar het dubbele EEPROM adres 'addr'. ByteForth
\G heeft ook library's voor de: 24C04, 24C08, 24C16 en de 24C65.
: SCHRIJF-BYTE  ( x addr -- )           \ I2C24C16 Schrijf byte naar d-adres in EEPROM
    OVER 7 AND 2*  EEPROM-ID  OR        \ Maak EEPROM device adres
    BEGIN
        START-BIT  DUP (BYTE-UIT)
    ACK? UNTIL                          \ Wacht op ackbit
    DROP  DU2/ DU2/ DU2/ DROP           \ Verwijder device adres, maak adres
    BYTE-UIT  BYTE-UIT  STOP-BIT        \ Stuur adres laag en databyte
    ;

\ Einde