\ ==============================================================
\ [TITLE]     AVR ByteForth MS host & target library. 
\ [FILE]      MS.FRT
\ [CATEGORY]  Library ( 34 to 40 bytes )
\ [VSN]       1.00 
\ [CREATED]   April 30, 1995, Willem Ouwerkerk 
\ [LASTCHNGD] Februari 28, 2003, Willem Ouwerkerk 
\ [COPYRIGHT] De Elektrise Schaar (C) 1995-2003
\ [USES]      AVR ByteForth cross compiler
\ [PURPOSE]   MS word for different cristal speeds
\             1MHz, 2MHz, 4MHz, 8MHz, 10, 11.059, 12MHz & 16 MHz
\ ==============================================================

1 CRYSTAL? [IF]

\G Wacht tenminste 'u' milliseconden. Er zijn versies beschikbaar
\G voor frequenties van 1, 2, 4, 8, 10, 11.059, 12 en 16 MHz.
CODE MS             ( u -- )            \ Ms "m-s" Wait for u milliseconds
    R16 X+ LD,                          \ 2
    DO, R17 10 LDI,                     \ 1
        DO, R18 32 LDI,                 \ 1
            DO, R18 LOOP,               \ 3
        R17 LOOP,                       \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE

\G Wacht tenminste 'u' maal 100 microseconden. Er zijn versies 
\G beschikbaar voor freq. van 1, 2, 4, 8, 10, 11.059, 12 en 16 MHz.
CODE /MS            ( u -- )            \ Ms "slash-m-s"
    R16 X+ LD,                          \ 2
    DO, R17 32 LDI,                     \ 1
        DO, R17 LOOP,                   \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE            

[THEN]

2 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    R16 X+ LD,                          \ 2
    DO, R17 10 LDI,                     \ 1
        DO, R18 66 LDI,                 \ 1
            DO, R18 LOOP,               \ 3
        R17 LOOP,                       \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    R16 X+ LD,                          \ 2
    DO, R17 66 LDI,                     \ 1
        DO, R17 LOOP,                   \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE            

[THEN]

4 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    R16 X+ LD,                          \ 2
    DO, R17 10 LDI,                     \ 1
        DO, R18 132 LDI,                \ 1
            DO, R18 LOOP,               \ 3
        R17 LOOP,                       \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    R16 X+ LD,                          \ 2
    DO, R17 132 LDI,                    \ 1
        DO, R17 LOOP,                   \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE            

[THEN]

8 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    R16 X+ LD,                          \ 2
    DO, R17 20 LDI,                     \ 1
        DO, R18 132 LDI,                \ 1
            DO, R18 LOOP,               \ 3
        R17 LOOP,                       \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    R16 X+ LD,                          \ 2
    DO, R17 200 LDI,                    \ 1
        DO, NOP, R17 LOOP,              \ 4
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE            

[THEN]

10 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    R16 X+ LD,                          \ 2
    DO, R17 25 LDI,                     \ 1
        DO, R18 132 LDI,                \ 1
            DO, R18 LOOP,               \ 3
        R17 LOOP,                       \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    R16 X+ LD,                          \ 2
    DO, R17 250 LDI,                    \ 1
        DO, NOP, R17 LOOP,              \ 4
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE            

[THEN]

11 CRYSTAL? [IF]                        \ Baudrate xtal: 11.059 

CODE MS             ( u -- )            \ Wait for u milliseconds
    R16 X+ LD,                          \ 2
    DO, R17 27 LDI,                     \ 1
        DO, R18 134 LDI,                \ 1
            DO, R18 LOOP,               \ 3
        R17 LOOP,                       \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    R16 X+ LD,                          \ 2
    DO, R18 220 LDI,                    \ 1
        DO, NOP, NOP, R18 LOOP,         \ 5
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE            

[THEN]

12 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    R16 X+ LD,                          \ 2
    DO, R17 30 LDI,                     \ 1
        DO, R18 132 LDI,                \ 1
            DO, R18 LOOP,               \ 3
        R17 LOOP,                       \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    R16 X+ LD,                          \ 2
    DO, R18 240 LDI,                    \ 1
        DO, NOP NOP, R18 LOOP,          \ 5
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE            

[THEN]

16 CRYSTAL? [IF]

CODE MS             ( u -- )            \ Wait for u milliseconds
    R16 X+ LD,                          \ 2
    DO, R17 40 LDI,                     \ 1
        DO, R18 132 LDI,                \ 1
            DO, R18 LOOP,               \ 3
        R17 LOOP,                       \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE

CODE /MS            ( u -- )            \ Ms "slash-m-s"
    R16 X+ LD,                          \ 2
    DO, R17 10 LDI,                     \ 1
        DO, R18 52 LDI,                 \ 1
            DO, R18 LOOP,               \ 3
        R17 LOOP,                       \ 3
    R16 LOOP,                           \ 3
    RET,                                \ 7
END-CODE            

[THEN]

\ End
