\ ==============================================================
\ [TITLE]     ByteForth, een degelijke PIR-invoer routine
\ [FILE]      PIR.FRT
\ [CATEGORY]  Passieve InfraRood invoer
\ [VSN]       1.01, 64 bytes
\ [CREATED]   October 26, 1996, Willem Ouwerkerk 
\ [LASTCHNGD] May 30, 2003, Willem Ouwerkerk 
\ [COPYRIGHT] De Elektrise Schaar (C) 1995-2003
\ [USES]      AVR ByteForth Cross Compiler
\ [PURPOSE]   Test passieve infrarood sensor code voor 4 MHz Xtal.
\             Laad correcte MS als een ander Xtal gebruikt wordt.
\ ==============================================================

PORTD 7 BIT-SFR PIR-IN                  \ Ingang voor PIR sensor is PD.7
                                        \ Wijzig dit adres als een andere
                                        \ ingang wordt gebruikt !!!!

\G Geef true als de PIR-sensor een warmbloedig wezen heeft gezien,
\G anders false. Een meting duurt 80 milliseconden.
: MENS-GEZIEN?      ( -- flag )         \ Pir "mens-gezien-query" Bemonster PIR sensor
    0 SETDIR PIR-IN   SET PIR-IN        \ PD.7 is een ingang, met pullup
    0                                   \ Zet teller op nul
    80 FOR                              \ Meet 80 keer
        FROM PIR-IN 0= IF               \ PIR geactiveerd ? (laag actief)
            1+                          \ Ja, verhoog teller
        THEN
        1 MS                            \ Wacht x microsec.
    NEXT
    60 - 0< 0=      ( 0>= )             \ Mens gezien als PIR zeker
    ;                                   \ 75 % van de tijd actief was.

\ End
