\ RC5 afstandbediening decoder voor de belofte voor 2001, Ushi; 204 bytes.

#00 CONSTANT RCTYPE                     \ RC5 zender type
                                        \ TV = 0, CD = 20 en VCR = 5
REGISTER RCSYS                          \ Systeem databyte (8 bits)
REGISTER RCDATA                         \ Commando databyte (6 bits)
REGISTER RC#                            \ Aantal onvangen bits

PIND  2 BIT-SFR ONTVANG-I               \ RC5-ingang
PORTD 2 BIT-SFR ONTVANG-U
DDRD  2 BIT-SFR ONTVANG-R


\G Geef true als er een voor dit systeem geldig RC5 commando is.
FLAG RCKEY?         ( -- flag )         \ Rc5 "r-c-key-question"

FLAG RCCONTROLE                         \ Eerste halve bit, voor controle
FLAG RCBIT                              \ Tweede halve bit, voor controle

CODE BEWAAR-RCBIT   ( -- )              \ Bewaar gedecodeerde bits
    CLC,                                \ Zet ontvangen bit in carry vlag
    ADR RCBIT SBRS,
    SEC,

    R16 ADR RC# MOV,                    \ Is bit teller kleiner dan 16 ?
    R16 $10 ANDI,
    ZER IF,                             \ Ja, dan is het een systeem bit ?
        ADR RCSYS ROL,
    ELSE,                               \ Nee, het is een data bit
        ADR RCDATA ROL,
    THEN,
    ADR RC# INC,                        \ Verhoog de bit teller
    RET,
END-CODE

CODE HERSTART       ( -- )
    R16 CLR,                            \ Stop timer-1
    TCCR1B R16 OUT,
    R16 $40 LDI,                        \ Extern-0 interrupt aan
    GIMSK R16 OUT,
    RET,
END-CODE

CODE LEES-BIT       ( -- )              \ Lees en decodeer een bit
    R16 PUSH,
    R17 PUSH,
    R17 SREG IN,

    R16 -438. NIP LDI,                  \ Zet tijd tot volgende meting 876 us
    TCNT1H R16 OUT,
    R16 -438. DROP LDI,                 \ plus 4 us looptijd = 880 us
    TCNT1L R16 OUT,

    CLT,
    ADR ONTVANG-I SBIC,                 \ Lees RC5 bit
    SET,
    ADR RCBIT BLD,                      \ Bewaar voor patroon controle

    ADR RC# 0 BST,                      \ Haal lage bit van bit-teller op
    TS IF,                              \ Verzamel elk even (tweede) bit ?
        ' BEWAAR-RCBIT GCALL,           \ Bewaar bit

        ADR RCCONTROLE BST,             \ Controleer bit patroon....
        R16 0 BLD,                      \ Lees vorig RC5 bit naar bit 0 van R16
        ADR RCBIT SBRS,                 \ Lees actuele RC5 bit
        R16 1 ADDI,                     \ Tel de bits bij elkaar op
        R16 1 ANDI,
        ZER IF,                         \ Geldig patroon 0/1 of 1/0 opgepikt ?

            R16 ADR RC# MOV,
            R16 $1C CPI,
            ZER IF,                     \ als er 14 bits opgepikt zijn ?

                R16 ADR RCDATA MOV,
                R16 $3F ANDI,           \ De lage 6 databits zijn geldig
                ADR RCDATA R16 MOV,

                R16 ADR RCSYS MOV,
                R16 $1F ANDI,           \ Pik zender ID op
                R16 RCTYPE CPI,         \ Is het een het juiste type ?
                ZER IF,
                    SET,                \ Ja, commando ontvangen !
                    ADR RCKEY? BLD,
                    ' HERSTART GCALL,
                THEN,
            THEN,
        ELSE,                           \ Ongeldig patroon, stop decoder
            ' HERSTART GCALL,           \ Interrupt aan
        THEN,
    ELSE,
        ADR RCBIT BST,                  \ Vis halve bit op
        ADR RCCONTROLE BLD,             \ en bewaar
        ADR RC# INC,                    \ Verhoog bit teller
    THEN,
    SREG R17 OUT,
    R17 POP,
    R16 POP,
    RETI,
END-CODE  T1-OVERFLOW

CODE RCSTART        ( -- )              \ Flank gezien, start decoder
    R16 PUSH,
    R17 PUSH,
    R17 SREG IN,
    ADR RCKEY? BST,
    TC IF,                              \ Vorige data verwerkt ?
        R16 CLR,
        GIMSK R16 OUT,
        R16 -223. NIP LDI,              \ Zet tijd tot eerste meting, 446 us 
        TCNT1H R16 OUT,
        R16 -223. DROP LDI,             \ plus 8 us = 454 us
        TCNT1L R16 OUT,
        R16 2 LDI,                      \ Prescaler = CK/8 = 500 KHz
        TCCR1B R16 OUT,
        ADR RC# CLR,                    \ Fake half ontvangen bit,
        ADR RC# INC,
        SET,
        ADR RCCONTROLE BLD,             \ dit fake bit is hoog !!!
    THEN,
    SREG R17 OUT,
    R17 POP,
    R16 POP,
    RETI,
END-CODE  EXTERN0

\G Initialiseer de RC5-decoder.
CODE SETUP-RC       ( -- )              \ Rc5  Installeer decoder hardware
    ADR ONTVANG-R CBI,                  \ PD.2 is de ingang
    ADR ONTVANG-U SBI,
    R16 2 LDI,                          \ Extern-0 actief op lage flanken
    MCUCR R16 OUT,
    R16 $40 LDI,                        \ Hardware interrupt aan
    GIMSK R16 OUT,
    R16 $80 LDI,                        \ Sta timer 1 interrupts toe
    TIMSK R16 OUT,
    R16 CLR,                            \ Timer 1 afgeschakeld
    TCCR1A R16 OUT,
    TCCR1B R16 OUT,
    CLT,                                \ Geen toets ontvangen
    ADR RCKEY? BLD,
    SEI,                                \ Zet interrupts aan
    RET,
END-CODE

\G Ontvang een RC5 databyte, 'x' is een code uit de gedefinieerde
\G RC5-code commando set. Bekijk hiervoor de RC5 device documentatie.
: RCKEY             ( -- x )            \ Rc5  "r-c-key" Wacht op een commando databyte
    BEGIN  RCKEY? UNTIL                 \ Wacht
    FROM RCDATA                         \ Laat commando achter
    CLEAR RCKEY?                        \ Sta volgend commando toe
    ;

\ Einde