\ ----------------------------------------------------------------------
\ LANGUAGE    : ByteForth
\ PROJECT     : AVR version of ByteForth
\ DESCRIPTION : CPU specific code
\ CATEGORY    : Standard Programs
\ AUTHOR      : Willem Ouwerkerk, June 06, 1999
\ LAST CHANGE : Willem Ouwerkerk, Juli 06, 2003  (ATtiny13)
\ ----------------------------------------------------------------------

90S1200? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR T0-OVERFLOW
#06. CPU-VECTOR COMPARATOR

$08 CONSTANT ACSR       $10 CONSTANT PIND       
$11 CONSTANT DDRD       $12 CONSTANT PORTD
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $1C CONSTANT EECR       
$1D CONSTANT EEDR       $1E CONSTANT EEAR
$21 CONSTANT WDTCR      $32 CONSTANT TCNT0
$33 CONSTANT TCCR0      $35 CONSTANT MCUCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3B CONSTANT GIMSK      $3F CONSTANT SREG

[THEN]

90S2313? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR EXTERN1
#06. CPU-VECTOR T1-CAPTURE
#08. CPU-VECTOR T1-COMPARE
#10. CPU-VECTOR T1-OVERFLOW
#12. CPU-VECTOR T0-OVERFLOW
#14. CPU-VECTOR UART-RX
#16. CPU-VECTOR UART-EMPTY
#18. CPU-VECTOR UART-TX
#20. CPU-VECTOR COMPARATOR

$08 CONSTANT ACSR       $09 CONSTANT UBRR
$0A CONSTANT UCR        $0B CONSTANT USR
$0C CONSTANT UDR        $10 CONSTANT PIND
$11 CONSTANT DDRD       $12 CONSTANT PORTD
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $1C CONSTANT EECR
$1D CONSTANT EEDR       $1E CONSTANT EEAR
$21 CONSTANT WDTCR      $24 CONSTANT ICR1L
$25 CONSTANT ICR1H      $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$35 CONSTANT MCUCR      $38 CONSTANT TIFR
$39 CONSTANT TIMSK      $3A CONSTANT GIFR
$3B CONSTANT GIMSK      $3D CONSTANT SPL
$3F CONSTANT SREG

[THEN]

90S2323? 90S2343? OR [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR T0-OVERFLOW

$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $1C CONSTANT EECR
$1D CONSTANT EEDR       $1E CONSTANT EEAR
$21 CONSTANT WDTCR      
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GIMSK
$3D CONSTANT SPL        $3F CONSTANT SREG

[THEN]

90S2333? 90S4433? OR [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR EXTERN1
#06. CPU-VECTOR T1-CAPTURE
#08. CPU-VECTOR T1-COMPARE
#10. CPU-VECTOR T1-OVERFLOW
#12. CPU-VECTOR T0-OVERFLOW
#14. CPU-VECTOR SPI-READY
#16. CPU-VECTOR UART-RX
#18. CPU-VECTOR UART-EMPTY
#20. CPU-VECTOR UART-TX
#22. CPU-VECTOR ADC-READY
#24. CPU-VECTOR EEPROM-READY
#26. CPU-VECTOR COMPARATOR

$03 CONSTANT UBRRHI
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSR      $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRR
$0A CONSTANT UCR        $0B CONSTANT USR
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEAR
$21 CONSTANT WDTCR      $26 CONSTANT ICR1L
$27 CONSTANT ICR1H
$2A CONSTANT OCR1L
$2B CONSTANT OCR1H      $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR
$35 CONSTANT MCUCR      $38 CONSTANT TIFR
$39 CONSTANT TIMSK      $3A CONSTANT GIFR
$3B CONSTANT GIMSK      $3D CONSTANT SPL
$3F CONSTANT SREG

[THEN]

90S4414? 90S8515? OR [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR EXTERN1
#06. CPU-VECTOR T1-CAPTURE
#08. CPU-VECTOR T1-COMPAREA
#10. CPU-VECTOR T1-COMPAREB
#12. CPU-VECTOR T1-OVERFLOW
#14. CPU-VECTOR T0-OVERFLOW
#16. CPU-VECTOR SPI-READY
#18. CPU-VECTOR UART-RX
#20. CPU-VECTOR UART-EMPTY
#22. CPU-VECTOR UART-TX
#24. CPU-VECTOR COMPARATOR

$08 CONSTANT ACSR       $09 CONSTANT UBRR
$0A CONSTANT UCR        $0B CONSTANT USR
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      
90S8515? [IF]  $1F CONSTANT EEARH  [THEN]
$21 CONSTANT WDTCR      $24 CONSTANT ICR1L
$25 CONSTANT ICR1H      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$35 CONSTANT MCUCR      $38 CONSTANT TIFR
$39 CONSTANT TIMSK      $3A CONSTANT GIFR
$3B CONSTANT GIMSK      $3D CONSTANT SPL
$3E CONSTANT SPH        $3F CONSTANT SREG

[THEN]

90S4434? 90S8535? OR [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR EXTERN1
#06. CPU-VECTOR T2-COMPARE
#08. CPU-VECTOR T2-OVERFLOW
#10. CPU-VECTOR T1-CAPTURE
#12. CPU-VECTOR T1-COMPAREA
#14. CPU-VECTOR T1-COMPAREB
#16. CPU-VECTOR T1-OVERFLOW
#18. CPU-VECTOR T0-OVERFLOW
#20. CPU-VECTOR SPI-READY
#22. CPU-VECTOR UART-RX
#24. CPU-VECTOR UART-EMPTY
#26. CPU-VECTOR UART-TX
#28. CPU-VECTOR ADC-READY
#30. CPU-VECTOR EEPROM-READY
#32. CPU-VECTOR COMPARATOR

$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSR      $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRR
$0A CONSTANT UCR        $0B CONSTANT USR
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$21 CONSTANT WDTCR      $22 CONSTANT ASSR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICR1H      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GIMSK
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]

tiny12? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR PIN-CHANGE
#06. CPU-VECTOR T0-OVERFLOW
#08. CPU-VECTOR EEPROM-READY
#10. CPU-VECTOR COMPARATOR

$08 CONSTANT ACSR
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $1C CONSTANT EECR
$1D CONSTANT EEDR       $1E CONSTANT EEAR
$21 CONSTANT WDTCR      $31 CONSTANT OSCCAL
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GIMSK
$3F CONSTANT SREG

[THEN]

tiny13? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR PIN-CHANGE0
#06. CPU-VECTOR T0-OVERFLOW
#08. CPU-VECTOR EEPROM-READY
#10. CPU-VECTOR COMPARATOR
#12. CPU-VECTOR T0-COMPAREA
#14. CPU-VECTOR T0-COMPAREB
#16. CPU-VECTOR WD-TIMEOUT
#18. CPU-VECTOR ADC-READY

$03 CONSTANT ADCSRB     $04 CONSTANT ADCL
$05 CONSTANT ADCH       $06 CONSTANT ADCSRA
$07 CONSTANT ADCMUX     $08 CONSTANT ACSR
$14 CONSTANT DIDR0      $15 CONSTANT PCMSK
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $1C CONSTANT EECR
$1D CONSTANT EEDR       $1E CONSTANT EEAR
$21 CONSTANT WDTCR      $26 CONSTANT CLKPR

$28 CONSTANT GTCCR      $29 CONSTANT OCR0B
$2E CONSTANT DWDR       $2F CONSTANT TCCR0A
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$31 CONSTANT OSCCAL     $32 CONSTANT TCNT0
$33 CONSTANT TCCR0B     $34 CONSTANT MCUSR
$35 CONSTANT MCUCR      $36 CONSTANT OCR0A
$37 CONSTANT SPMCSR     $38 CONSTANT TIFR
$39 CONSTANT TIMSK0     $3A CONSTANT GIFR
$3B CONSTANT GIMSK      $3D CONSTANT SPL
$3F CONSTANT SREG

[THEN]

tiny15? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR PIN-CHANGE
#06. CPU-VECTOR T1-COMPARE
#08. CPU-VECTOR T1-OVERFLOW
#10. CPU-VECTOR T0-OVERFLOW
#12. CPU-VECTOR EEPROM-READY
#14. CPU-VECTOR COMPARATOR
#16. CPU-VECTOR ADC-READY

$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSR      $07 CONSTANT ADMUX
$08 CONSTANT ACSR
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $1C CONSTANT EECR
$1D CONSTANT EEDR       $1E CONSTANT EEAR
$21 CONSTANT WDTCR      
$2C CONSTANT SFIOR      $2D CONSTANT OCR1B
$2E CONSTANT OCR1A      $2F CONSTANT TCNT1
$30 CONSTANT TCCR1      $31 CONSTANT OSCCAL
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GIMSK
$3F CONSTANT SREG

[THEN]

tiny22? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR T0-OVERFLOW

$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $1C CONSTANT EECR
$1D CONSTANT EEDR       $1E CONSTANT EEAR
$21 CONSTANT WDTCR      
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GIMSK
$3D CONSTANT SPL        $3F CONSTANT SREG

[THEN]

tiny26? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR PIN-CHANGE
#06. CPU-VECTOR T1-COMPAREA
#08. CPU-VECTOR T1-COMPAREB
#10. CPU-VECTOR T1-OVERFLOW
#12. CPU-VECTOR T0-OVERFLOW
#14. CPU-VECTOR USI-START
#16. CPU-VECTOR USI-OVERFLOW
#18. CPU-VECTOR EEPROM-READY
#20. CPU-VECTOR COMPARATOR
#22. CPU-VECTOR ADC-READY

$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSR      $07 CONSTANT ADMUX
$08 CONSTANT ACSR
$0D CONSTANT USICR      $0E CONSTANT USISR
$0F CONSTANT USIDR
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      
$19 CONSTANT PINA       $1A CONSTANT DDRA
$1B CONSTANT PORTA      $1C CONSTANT EECR
$1D CONSTANT EEDR       $1E CONSTANT EEAR
$21 CONSTANT WDTCR      $29 CONSTANT PLLCSR
$2B CONSTANT OCR1C      $2C CONSTANT OCR1B
$2D CONSTANT OCR1A      $2E CONSTANT TCNT1
$2F CONSTANT TCCR1B

$30 CONSTANT TCCR1A     $31 CONSTANT OSCCAL
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GIMSK
$3D CONSTANT SPL        $3F CONSTANT SREG

[THEN]

mega161? [IF]

#04. CPU-VECTOR EXTERN0
#08. CPU-VECTOR EXTERN1
#12. CPU-VECTOR EXTERN2
#16. CPU-VECTOR T2-COMPARE
#20. CPU-VECTOR T2-OVERFLOW
#24. CPU-VECTOR T1-CAPTURE
#28. CPU-VECTOR T1-COMPAREA
#32. CPU-VECTOR T1-COMPAREB
#36. CPU-VECTOR T1-OVERFLOW
#40. CPU-VECTOR T0-OVERFLOW
#44. CPU-VECTOR SPI-READY
#48. CPU-VECTOR UART0-RX
#52. CPU-VECTOR UART1-RX
#56. CPU-VECTOR UART0-EMPTY
#60. CPU-VECTOR UART1-EMPTY
#64. CPU-VECTOR UART0-TX
#68. CPU-VECTOR UART1-TX
#72. CPU-VECTOR EEPROM-READY
#76. CPU-VECTOR COMPARATOR

$00 CONSTANT UBBR1      $01 CONSTANT UCSR1B
$02 CONSTANT UCSR1A     $03 CONSTANT UDR1
                        $05 CONSTANT PINE
$06 CONSTANT DDRE       $07 CONSTANT PORTE
$08 CONSTANT ACSR       $09 CONSTANT UBRR0
$0A CONSTANT UCSR0B     $0B CONSTANT UCSR0A
$0C CONSTANT UDR0       $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UBRRHI
$21 CONSTANT WDTCR      $22 CONSTANT OCR2
$23 CONSTANT TCNT2      $24 CONSTANT ICR1L
$25 CONSTANT ICR1H      $26 CONSTANT ASSR
$27 CONSTANT TCCR2      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT SFIOR
$31 CONSTANT OCR0
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$36 CONSTANT EMCUCR     $37 CONSTANT SPMCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GIMSK
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]

mega162? [IF]

#04. CPU-VECTOR EXTERN0
#08. CPU-VECTOR EXTERN1
#12. CPU-VECTOR EXTERN2
#16. CPU-VECTOR PIN-CHANGE0
#20. CPU-VECTOR PIN-CHANGE1
#24. CPU-VECTOR T3-CAPTURE
#28. CPU-VECTOR T3-COMPAREA
#32. CPU-VECTOR T3-COMPAREB
#36. CPU-VECTOR T3-OVERFLOW

#40. CPU-VECTOR T2-COMPARE
#44. CPU-VECTOR T2-OVERFLOW
#48. CPU-VECTOR T1-CAPTURE
#52. CPU-VECTOR T1-COMPAREA
#56. CPU-VECTOR T1-COMPAREB
#60. CPU-VECTOR T1-OVERFLOW
#64. CPU-VECTOR T0-COMPARE
#68. CPU-VECTOR T0-OVERFLOW
#72. CPU-VECTOR SPI-READY
#76. CPU-VECTOR UART-RX0
#80. CPU-VECTOR UART-RX1
#84. CPU-VECTOR UART-EMPTY0
#88. CPU-VECTOR UART-EMPTY1
#92. CPU-VECTOR UART-TX0
#96. CPU-VECTOR UART-TX1
#100. CPU-VECTOR EEPROM-READY
#104. CPU-VECTOR COMPARATOR
#108. CPU-VECTOR SPM-READY

$00 CONSTANT IBRR1L     $01 CONSTANT UCSR1B
$02 CONSTANT UCSR1A     $03 CONSTANT UDR1
$04 CONSTANT OCDR       $04 CONSTANT OSCCAL
$05 CONSTANT PINE       $06 CONSTANT DDRE
$07 CONSTANT PORTE
$08 CONSTANT ACSR       $09 CONSTANT UBRR0L
$0A CONSTANT UCSR0B     $0B CONSTANT UCSR0A
$0C CONSTANT UDR0       $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UBRR0H     $20 CONSTANT UCSR0C
$21 CONSTANT WDTCR      $22 CONSTANT OCR2
$23 CONSTANT TCNT2
$24 CONSTANT ICR1L      $25 CONSTANT ICRIH
$26 CONSTANT ASSR       $27 CONSTANT TCCR2
$28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT SFIOR
$31 CONSTANT OCR0
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUCSR     $35 CONSTANT MCUCR
$36 CONSTANT EMCUCR     $37 CONSTANT SPMCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GICR
$3C CONSTANT UCSR1C     $3C CONSTANT UBRR1H
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

\ SFR's die buiten het bereik van IN, en OUT, liggen.
\ Ze moeten met LDS, en STS, benaderd worden.
$61 CONSTANT CLKPR
$6B CONSTANT PCMSK0     $6C CONSTANT PCMSK1
$7C CONSTANT ETIFR      $7D CONSTANT ATIMSK
$80 CONSTANT ICR3L      $81 CONSTANT ICR3H
$84 CONSTANT OCR3BL     $85 CONSTANT OCR3BH
$86 CONSTANT OCR3AL     $87 CONSTANT OCR2AH
$88 CONSTANT TCNT3L     $89 CONSTANT TCNT3H
$8A CONSTANT TCCR3B     $8B CONSTANT TCCR3A

[THEN]

90S8555? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR EXTERN1
#06. CPU-VECTOR T2-COMPARE
#08. CPU-VECTOR T2-OVERFLOW
#10. CPU-VECTOR T1-CAPTURE
#12. CPU-VECTOR T1-COMPAREA
#14. CPU-VECTOR T1-COMPAREB
#16. CPU-VECTOR T1-OVERFLOW
#18. CPU-VECTOR T0-OVERFLOW
#20. CPU-VECTOR SPI-READY
#22. CPU-VECTOR UART-RX
#24. CPU-VECTOR UART-EMPTY
#26. CPU-VECTOR UART-TX
#28. CPU-VECTOR ADC-READY
#30. CPU-VECTOR EEPROM-READY
#32. CPU-VECTOR COMPARATOR
#34. CPU-VECTOR TWI-READY

$00 CONSTANT TWBR       $01 CONSTANT TWSR
$02 CONSTANT TWAR       $03 CONSTANT TWDR
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSR      $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRR
$0A CONSTANT UCSRB      $0B CONSTANT UCSRA
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UBRRHI
$21 CONSTANT WDTCR      $22 CONSTANT ASSR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICRIH      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT SFIOR
$31 CONSTANT OSCCAL
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$36 CONSTANT TWCR       $37 CONSTANT SPMCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GIMSK
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]

mega163? [IF]

#04. CPU-VECTOR EXTERN0
#08. CPU-VECTOR EXTERN1
#12. CPU-VECTOR T2-COMPARE
#16. CPU-VECTOR T2-OVERFLOW
#20. CPU-VECTOR T1-CAPTURE
#24. CPU-VECTOR T1-COMPAREA
#28. CPU-VECTOR T1-COMPAREB
#32. CPU-VECTOR T1-OVERFLOW
#36. CPU-VECTOR T0-OVERFLOW
#40. CPU-VECTOR SPI-READY
#44. CPU-VECTOR UART-RX
#48. CPU-VECTOR UART-EMPTY
#52. CPU-VECTOR UART-TX
#56. CPU-VECTOR ADC-READY
#60. CPU-VECTOR EEPROM-READY
#64. CPU-VECTOR COMPARATOR
#68. CPU-VECTOR TWI-READY

$00 CONSTANT TWBR       $01 CONSTANT TWSR
$02 CONSTANT TWAR       $03 CONSTANT TWDR
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSR      $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRR
$0A CONSTANT UCSRB      $0B CONSTANT UCSRA
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UBRRHI
$21 CONSTANT WDTCR      $22 CONSTANT ASSR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICRIH      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT SFIOR
$31 CONSTANT OSCCAL
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$36 CONSTANT TWCR       $37 CONSTANT SPMCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GIMSK
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]

mega323? [IF]

#04. CPU-VECTOR EXTERN0
#08. CPU-VECTOR EXTERN1
#12. CPU-VECTOR EXTERN1
#16. CPU-VECTOR T2-COMPARE
#20. CPU-VECTOR T2-OVERFLOW
#24. CPU-VECTOR T1-CAPTURE
#28. CPU-VECTOR T1-COMPAREA
#32. CPU-VECTOR T1-COMPAREB
#36. CPU-VECTOR T1-OVERFLOW
#40. CPU-VECTOR T0-COMPARE
#44. CPU-VECTOR T0-OVERFLOW
#48. CPU-VECTOR SPI-READY
#52. CPU-VECTOR UART-RX
#56. CPU-VECTOR UART-EMPTY
#60. CPU-VECTOR UART-TX
#64. CPU-VECTOR ADC-READY
#68. CPU-VECTOR EEPROM-READY
#72. CPU-VECTOR COMPARATOR
#76. CPU-VECTOR TWI-READY

$00 CONSTANT TWBR       $01 CONSTANT TWSR
$02 CONSTANT TWAR       $03 CONSTANT TWDR
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSR      $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRRL
$0A CONSTANT UCSRB      $0B CONSTANT UCSRA
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UBRRH      $20 CONSTANT UCSRC
$21 CONSTANT WDTCR      $22 CONSTANT ASSR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICRIH      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT SFIOR
$31 CONSTANT OSCCAL     $31 CONSTANT OCDR
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUCSR     $35 CONSTANT MCUCR
$36 CONSTANT TWCR       $37 CONSTANT SPMCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GICR
$3C CONSTANT OCR0       $3D CONSTANT SPL
$3E CONSTANT SPH        $3F CONSTANT SREG

[THEN]

mega103? [IF]

#04. CPU-VECTOR EXTERN0
#08. CPU-VECTOR EXTERN1
#12. CPU-VECTOR EXTERN2
#16. CPU-VECTOR EXTERN3
#20. CPU-VECTOR EXTERN4
#24. CPU-VECTOR EXTERN5
#28. CPU-VECTOR EXTERN6
#32. CPU-VECTOR EXTERN7
#36. CPU-VECTOR T2-COMPARE
#40. CPU-VECTOR T2-OVERFLOW
#44. CPU-VECTOR T1-CAPTURE
#48. CPU-VECTOR T1-COMPAREA
#52. CPU-VECTOR T1-COMPAREB
#56. CPU-VECTOR T1-OVERFLOW
#60. CPU-VECTOR T0-COMPARE
#64. CPU-VECTOR T0-OVERFLOW
#68. CPU-VECTOR SPI-READY
#72. CPU-VECTOR UART-RX
#76. CPU-VECTOR UART-EMPTY
#80. CPU-VECTOR UART-TX
#84. CPU-VECTOR ADC-READY
#88. CPU-VECTOR EEPROM-READY
#92. CPU-VECTOR COMPARATOR

$00 CONSTANT PINF       $01 CONSTANT PINE
$02 CONSTANT DDRE       $03 CONSTANT PORTE
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSR      $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRR
$0A CONSTANT UCR        $0B CONSTANT USR
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$21 CONSTANT WDTCR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICRIH      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT ASSR
$31 CONSTANT OCR0
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUSR      $35 CONSTANT MCUCR
$36 CONSTANT TIFR       $37 CONSTANT TIMSK
$38 CONSTANT EIFR       $39 CONSTANT EIMSK
$3A CONSTANT EICR       $3B CONSTANT RAMPZ
$3C CONSTANT XDIV
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]

mega8? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR EXTERN1
#06. CPU-VECTOR T2-COMPARE
#08. CPU-VECTOR T2-OVERFLOW
#10. CPU-VECTOR T1-CAPTURE
#12. CPU-VECTOR T1-COMPAREA
#14. CPU-VECTOR T1-COMPAREB
#16. CPU-VECTOR T1-OVERFLOW
#18. CPU-VECTOR T0-OVERFLOW
#20. CPU-VECTOR SPI-READY
#22. CPU-VECTOR UART-RX
#24. CPU-VECTOR UART-EMPTY
#26. CPU-VECTOR UART-TX
#28. CPU-VECTOR ADC-READY
#30. CPU-VECTOR EEPROM-READY
#32. CPU-VECTOR COMPARATOR
#34. CPU-VECTOR TWI-READY
#36. CPU-VECTOR SPM-READY

$00 CONSTANT TWBR       $01 CONSTANT TWSR
$02 CONSTANT TWAR       $03 CONSTANT TWDR
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSR      $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRRL
$0A CONSTANT UCSRB      $0B CONSTANT UCSRA
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UCSRC      $20 CONSTANT UBRRH
$21 CONSTANT WDTCR      $22 CONSTANT ASSR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICRIH      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT SFIOR
$31 CONSTANT OSCCAL
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUCSR     $35 CONSTANT MCUCR
$36 CONSTANT TWCR       $37 CONSTANT SPMCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GICR
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]

mega16? [IF]

#04. CPU-VECTOR EXTERN0
#08. CPU-VECTOR EXTERN1
#12. CPU-VECTOR T2-COMPARE
#16. CPU-VECTOR T2-OVERFLOW
#20. CPU-VECTOR T1-CAPTURE
#24. CPU-VECTOR T1-COMPAREA
#28. CPU-VECTOR T1-COMPAREB
#32. CPU-VECTOR T1-OVERFLOW
#36. CPU-VECTOR T0-OVERFLOW
#40. CPU-VECTOR SPI-READY
#44. CPU-VECTOR UART-RX
#48. CPU-VECTOR UART-EMPTY
#52. CPU-VECTOR UART-TX
#56. CPU-VECTOR ADC-READY
#60. CPU-VECTOR EEPROM-READY
#64. CPU-VECTOR COMPARATOR
#68. CPU-VECTOR TWI-READY
#72. CPU-VECTOR EXTERN2
#76. CPU-VECTOR T0-COMPARE
#80. CPU-VECTOR SPM-READY

$00 CONSTANT TWBR       $01 CONSTANT TWSR
$02 CONSTANT TWAR       $03 CONSTANT TWDR
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSRA     $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRRL
$0A CONSTANT UCSRB      $0B CONSTANT UCSRA
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UCSRC      $20 CONSTANT UBRRH
$21 CONSTANT WDTCR      $22 CONSTANT ASSR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICRIH      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT SFIOR
$31 CONSTANT OSCCAL     $31 CONSTANT OCDR
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUCSR     $35 CONSTANT MCUCR
$36 CONSTANT TWCR       $37 CONSTANT SPMCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GICR
$3C CONSTANT OCR0
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]

mega32? [IF]

#04. CPU-VECTOR EXTERN0
#08. CPU-VECTOR EXTERN1
#12. CPU-VECTOR EXTERN2
#16. CPU-VECTOR T2-COMPARE
#20. CPU-VECTOR T2-OVERFLOW
#24. CPU-VECTOR T1-CAPTURE
#28. CPU-VECTOR T1-COMPAREA
#32. CPU-VECTOR T1-COMPAREB
#36. CPU-VECTOR T1-OVERFLOW
#40. CPU-VECTOR T0-COMPARE
#44. CPU-VECTOR T0-OVERFLOW
#48. CPU-VECTOR SPI-READY
#52. CPU-VECTOR UART-RX
#56. CPU-VECTOR UART-EMPTY
#60. CPU-VECTOR UART-TX
#64. CPU-VECTOR ADC-READY
#68. CPU-VECTOR EEPROM-READY
#72. CPU-VECTOR COMPARATOR
#76. CPU-VECTOR TWI-READY
#80. CPU-VECTOR SPM-READY

$00 CONSTANT TWBR       $01 CONSTANT TWSR
$02 CONSTANT TWAR       $03 CONSTANT TWDR
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSRA     $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRRL
$0A CONSTANT UCSRB      $0B CONSTANT UCSRA
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UBRRH      $20 CONSTANT UCSRC
$21 CONSTANT WDTCR      $22 CONSTANT ASSR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICRIH      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT SFIOR
$31 CONSTANT OSCCAL     $31 CONSTANT OCDR
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUCSR     $35 CONSTANT MCUCR
$36 CONSTANT TWCR       $37 CONSTANT SPMCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GICR
$3C CONSTANT OCR0
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]

mega64? [IF]

#04. CPU-VECTOR EXTERN0
#08. CPU-VECTOR EXTERN1
#12. CPU-VECTOR EXTERN2
#16. CPU-VECTOR EXTERN3
#20. CPU-VECTOR EXTERN4
#24. CPU-VECTOR EXTERN5
#28. CPU-VECTOR EXTERN6
#32. CPU-VECTOR EXTERN7
#36. CPU-VECTOR T2-COMPARE
#40. CPU-VECTOR T2-OVERFLOW
#44. CPU-VECTOR T1-CAPTURE
#48. CPU-VECTOR T1-COMPAREA
#52. CPU-VECTOR T1-COMPAREB
#56. CPU-VECTOR T1-OVERFLOW
#60. CPU-VECTOR T0-COMPARE
#64. CPU-VECTOR T0-OVERFLOW
#68. CPU-VECTOR SPI-READY
#72. CPU-VECTOR UART0-RX
#76. CPU-VECTOR UART0-EMPTY
#80. CPU-VECTOR UART0-TX
#84. CPU-VECTOR ADC-READY
#88. CPU-VECTOR EEPROM-READY
#92. CPU-VECTOR COMPARATOR
#96. CPU-VECTOR T1-COMPAREC
#100. CPU-VECTOR T3-CAPTURE
#104. CPU-VECTOR T3-COMPAREA
#108. CPU-VECTOR T3-COMPAREB
#112. CPU-VECTOR T3-COMPAREC
#116. CPU-VECTOR T3-OVERFLOW
#120. CPU-VECTOR UART1-RX
#124. CPU-VECTOR UART1-EMPTY
#128. CPU-VECTOR UART1-TX
#132. CPU-VECTOR TWI-READY
#136. CPU-VECTOR SPM-READY

$00 CONSTANT PINF       $01 CONSTANT PINE
$02 CONSTANT DDRE       $03 CONSTANT PORTE
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSRA     $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRR0L
$0A CONSTANT UCSR0B     $0B CONSTANT UCSR0A
$0C CONSTANT UDR0       $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT SFIOR
$21 CONSTANT WDTCR      $22 CONSTANT OCDR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICRIH      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A     $30 CONSTANT ASSR
$31 CONSTANT OCR0
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUCSR     $35 CONSTANT MCUCR
$36 CONSTANT TIFR       $37 CONSTANT TIMSK
$38 CONSTANT EIFR       $39 CONSTANT EIMSK
$3A CONSTANT EICRB
$3C CONSTANT XDIV
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]

mega8515? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR EXTERN1
#06. CPU-VECTOR T1-CAPTURE
#08. CPU-VECTOR T1-COMPAREA
#10. CPU-VECTOR T1-COMPAREB
#12. CPU-VECTOR T1-OVERFLOW
#14. CPU-VECTOR T0-OVERFLOW
#16. CPU-VECTOR SPI-READY
#18. CPU-VECTOR UART-RX
#20. CPU-VECTOR UART-EMPTY
#22. CPU-VECTOR UART-TX
#24. CPU-VECTOR COMPARATOR
#26. CPU-VECTOR EXTERN2
#28. CPU-VECTOR T0-COMPARE
#30. CPU-VECTOR EEPROM-READY
#32. CPU-VECTOR SPM-READY

$04 CONSTANT OSCCAL     $05 CONSTANT PINE
$06 CONSTANT DDRE       $07 CONSTANT PORTE
$08 CONSTANT ACSR       $09 CONSTANT UBRRL
$0A CONSTANT UCSRB      $0B CONSTANT UCSRA
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UCSRC      $20 CONSTANT UBRRH
$21 CONSTANT WDTCR      $24 CONSTANT ICR1L
$25 CONSTANT ICR1H      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A
$30 CONSTANT SFIOR      $31 CONSTANT OCR0
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUCSR     $35 CONSTANT MCUCR      
$36 CONSTANT EMCUCR
$37 CONSTANT SPMCR      $38 CONSTANT TIFR
$39 CONSTANT TIMSK      $3A CONSTANT GIFR
$3B CONSTANT GICR       $3D CONSTANT SPL
$3E CONSTANT SPH        $3F CONSTANT SREG

[THEN]


mega169? [IF]

#04. CPU-VECTOR EXTERN0
#08. CPU-VECTOR PIN-CHANGE0
#12. CPU-VECTOR PIN-CHANGE1
#16. CPU-VECTOR T2-COMPARE
#20. CPU-VECTOR T2-OVERFLOW
#24. CPU-VECTOR T1-CAPTURE
#28. CPU-VECTOR T1-COMPAREA
#32. CPU-VECTOR T1-COMPAREB
#36. CPU-VECTOR T1-OVERFLOW
#40. CPU-VECTOR T0-COMPARE
#44. CPU-VECTOR T0-OVERFLOW
#48. CPU-VECTOR SPI-READY
#52. CPU-VECTOR USART-RX0
#56. CPU-VECTOR USART-EMPTY0
#60. CPU-VECTOR USART-TX0
#64. CPU-VECTOR USI-START
#68. CPU-VECTOR USI-OVERFLOW
#72. CPU-VECTOR COMPARATOR
#76. CPU-VECTOR ADC-READY
#80. CPU-VECTOR EEPROM-READY
#84. CPU-VECTOR SPM-READY
#88. CPU-VECTOR LCD-START

$00 CONSTANT PINA       $01 CONSTANT DDRA
$02 CONSTANT PORTA      $03 CONSTANT PINB
$04 CONSTANT DDRB       $05 CONSTANT PORTB
$06 CONSTANT PINC       $07 CONSTANT DDRC
$08 CONSTANT PORTC      $09 CONSTANT PIND
$0A CONSTANT DDRD       $0B CONSTANT PORTD
$0C CONSTANT PINE       $0D CONSTANT DDRE
$0E CONSTANT PORTE      $0F CONSTANT PINF
$10 CONSTANT DDRF       $11 CONSTANT PORTF
$12 CONSTANT PING       $13 CONSTANT DDRG
$14 CONSTANT PORTG      $15 CONSTANT TIFR0
$16 CONSTANT TIFR1      $17 CONSTANT TIFR2
$1C CONSTANT EIFR       $1D CONSTANT EIMSK
$1E CONSTANT GPIOR0     $1F CONSTANT EECR
$20 CONSTANT EEDR       $21 CONSTANT EEARL
$22 CONSTANT EEARH
$23 CONSTANT GTCCR      $24 CONSTANT TCCR0A
$26 CONSTANT TCNT0      $27 CONSTANT OCR0A
$2A CONSTANT GPIOR1     $2B CONSTANT GPIOR2
$2C CONSTANT SPCR
$2D CONSTANT SPSR       $2E CONSTANT SPDR
$30 CONSTANT ACSR       $31 CONSTANT OCDR
$33 CONSTANT SMCR       $34 CONSTANT MCUCSR
$35 CONSTANT MCUCR
$37 CONSTANT SPMCSR
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

\ SFR's die buiten het bereik van IN, en OUT, liggen.
\ Ze moeten met LDS, en STS, benaderd worden.
$60 CONSTANT WDTCR      $61 CONSTANT CLKPR
$66 CONSTANT OSCCAL
$6B CONSTANT PCMSK0     $6C CONSTANT PCMSK1
$6E CONSTANT TIMSK0     $6F CONSTANT TIMSK1        
$70 CONSTANT TIMSK2

$78 CONSTANT ADCL       $79 CONSTANT ADCH
$7A CONSTANT ADCSRA     $7B CONSTANT ADCSRB
$7C CONSTANT ADMUX
$7E CONSTANT DIDR0      $7F CONSTANT DIDR1

$80 CONSTANT TCCR1A     $81 CONSTANT TCCR1B
$82 CONSTANT TCCR1C

$84 CONSTANT TCNT1L     $85 CONSTANT TCNT1H
$86 CONSTANT ICR1L      $87 CONSTANT ICR1H
$88 CONSTANT OCR1AL     $89 CONSTANT OCR1AH
$8A CONSTANT OCR1BL     $8B CONSTANT OCR1BH

$B0 CONSTANT TCCR2A
$B2 CONSTANT TCNT2      $B3 CONSTANT OCR2A
$B6 CONSTANT ASSR       $B8 CONSTANT USICR
$8A CONSTANT USISR      $8B CONSTANT USIDR

[THEN]

mega8535? [IF]

#02. CPU-VECTOR EXTERN0
#04. CPU-VECTOR EXTERN1
#06. CPU-VECTOR T2-COMPARE
#08. CPU-VECTOR T2-OVERFLOW
#10. CPU-VECTOR T1-CAPTURE
#12. CPU-VECTOR T1-COMPAREA
#14. CPU-VECTOR T1-COMPAREB
#16. CPU-VECTOR T1-OVERFLOW
#18. CPU-VECTOR T0-OVERFLOW
#20. CPU-VECTOR SPI-READY
#22. CPU-VECTOR USART-RX
#24. CPU-VECTOR USART-EMPTY
#26. CPU-VECTOR USART-TX
#28. CPU-VECTOR ADC-READY
#30. CPU-VECTOR EEPROM-READY
#32. CPU-VECTOR COMPARATOR
#34. CPU-VECTOR TWI-READY
#36. CPU-VECTOR EXTERN2
#38. CPU-VECTOR T0-COMPARE
#40. CPU-VECTOR SPM-READY

$00 CONSTANT TWBR       $01 CONSTANT TWSR
$02 CONSTANT TWAR       $03 CONSTANT TWDR
$04 CONSTANT ADCL       $05 CONSTANT ADCH
$06 CONSTANT ADCSRA     $07 CONSTANT ADMUX
$08 CONSTANT ACSR       $09 CONSTANT UBRRL
$0A CONSTANT UCSRB      $0B CONSTANT UCSRA
$0C CONSTANT UDR        $0D CONSTANT SPCR
$0E CONSTANT SPSR       $0F CONSTANT SPDR
$10 CONSTANT PIND       $11 CONSTANT DDRD
$12 CONSTANT PORTD      $13 CONSTANT PINC
$14 CONSTANT DDRC       $15 CONSTANT PORTC
$16 CONSTANT PINB       $17 CONSTANT DDRB
$18 CONSTANT PORTB      $19 CONSTANT PINA
$1A CONSTANT DDRA       $1B CONSTANT PORTA
$1C CONSTANT EECR       $1D CONSTANT EEDR
$1E CONSTANT EEARL      $1F CONSTANT EEARH
$20 CONSTANT UBRRH      $20 CONSTANT UCSRC
$21 CONSTANT WDTCR      $22 CONSTANT ASSR
$23 CONSTANT OCR2       $24 CONSTANT TCNT2
$25 CONSTANT TCCR2      $26 CONSTANT ICR1L
$27 CONSTANT ICR1H      $28 CONSTANT OCR1BL
$29 CONSTANT OCR1BH     $2A CONSTANT OCR1AL
$2B CONSTANT OCR1AH     $2C CONSTANT TCNT1L
$2D CONSTANT TCNT1H     $2E CONSTANT TCCR1B
$2F CONSTANT TCCR1A
$30 CONSTANT SFIOR      $31 CONSTANT OSCCAL
$32 CONSTANT TCNT0      $33 CONSTANT TCCR0
$34 CONSTANT MCUCSR     $35 CONSTANT MCUCR
$36 CONSTANT TWCR       $37 CONSTANT SPMCR
$38 CONSTANT TIFR       $39 CONSTANT TIMSK
$3A CONSTANT GIFR       $3B CONSTANT GICR
$3C CONSTANT OCR0
$3D CONSTANT SPL        $3E CONSTANT SPH
$3F CONSTANT SREG

[THEN]


\ 03-01-02, added three basic Forth constants too.

$20 CONSTANT BL
$FF CONSTANT TRUE
$00 CONSTANT FALSE

                               ( End )
