\ ==============================================================
\ [TITLE]     AVR ByteForth ADC0834CN AD code
\ [FILE]      TLC834T1.FRT
\ [CATEGORY]  Library ( 134 bytes )
\ [VSN]       1.00
\ [CREATED]   August 17, 2000, Willem Ouwerkerk 
\ [LASTCHNGD] August 18, 2000, Willem Ouwerkerk 
\ [COPYRIGHT] De Elektrise Schaar (C) 2000-
\ [USES]      AVR ByteForth cross compiler
\ [PURPOSE]   Eight bit serial AD Converter with 4 inputs.
\             Note that minimum hi&lo clock pulse is 1 microsec.
\             This code uses a three wire interface
\ ==============================================================

PORTD 3 BIT-SFR ADC-KLOK                \ ADC klokpuls invoer
PORTD 4 BIT-SFR ADC-DATA                \ ADC data in/uitvoer
PORTD 5 BIT-SFR ADC-SELECTEER           \ ADC activeer/selecteer invoer

\G Initialiseer de ADC-interface voor de TLC834CN.
: SETUP-ADC         ( -- )              \ TLC834CN  "setup-a-d-c"  activeer I/O richting
    1 SETDIR ADC-KLOK                   \ Uitvoer
    1 SETDIR ADC-SELECTEER              \ Uitvoer
    CLEAR ADC-KLOK                      \ Zet klok klaar
    ;

: KLOK              ( -- )              \ Geef klokpuls
    SET ADC-KLOK  NOOP NOOP
    CLEAR ADC-KLOK
    ;

\G Lees de ADC ingang '+n', 'u' is het resultaat van deze conversie.
: ADC               ( +n -- u )         \ TLC834CN "a-d-c"  Doe omzetting van ing. +n
    1 SETDIR ADC-DATA                   \ ADC-DATA is uitvoer
    CLEAR ADC-SELECTEER                 \ Start omzetting
    DUP 1 AND 2*  SWAP 2 AND U2/  OR    \ Zet adres bits op juiste plaats
    $0C OR                              \ Voeg startbit & SGL-bit toe
    4 FOR                               \ Zend ingangs data naar ADC
        DUP 8 AND TO ADC-DATA
        KLOK  2*
    NEXT                                \ Rest data blijft op de stack
    0 SETDIR ADC-DATA                   \ ADC-DATA is invoer
    8 FOR  KLOK  NEXT                   \ Doe AD-omzetting
    8 FOR                               \ Data bestaat uit 8 bits
        U2/  FROM ADC-DATA  128 AND  OR \ Schaal data in en lees volgend bit
        KLOK                            \ Schuif volgend bit naar buiten
    NEXT
    KLOK  SET ADC-SELECTEER             \ Stop omzetting
    ;

\ Einde
