\ ----------------------------------------------------------------------
\ LANGUAGE    : AVR ByteForth
\ PROJECT     : Demonstratie software
\ DESCRIPTION : Looplicht op poort B
\ CATEGORY    : Applicatie, afm: 152 bytes.
\ AUTHOR      : Willem Ouwerkerk, Oktober 22, 1999
\ LAST CHANGE : Willem Ouwerkerk, Oktober 22, 1999
\ ----------------------------------------------------------------------

90S8515                                 \ Compileer voor AT90S8515

NEEDS TARGET.FRT                        \ Laad labels & vectoren voor 90S8515

PORTB   SFR LEDS                        \ Poort B met 8 leds

: KNIPPER       ( -- )                  \ Visualiseer opstarten
    0 TO LEDS   250 MS                  \ Alle leds aan
    -1 TO LEDS  250 MS                  \ Alle leds uit
    ;

: LOOPLICHT     ( -- )
    SETUP-BYTEFORTH                     \ Installeer Forth machine
    $FF SETDIR LEDS                     \ Poort B wordt gebruikt als uitgang
    KNIPPER
    BEGIN
        8 0 DO                          \ Doe lus acht maal
            1 I LSHIFT                  \ Maak bitpatroon
            INVERT TO LEDS              \ Keer om en stuur de leds aan
            100 MS                      \ Wacht even
        LOOP
    AGAIN                               \ Begin weer opnieuw
    ;  MAIN                             \ LOOPLICHT start op na een reset

                               ( End )
